"""
Package checks provides utilities to check for certain properties of a sequence.

"""
# python wrapper for package github.com/bebop/poly/checks within overall package checks
# This is what you import to use the package.
# File is generated by gopy. Do not edit.
# gopy build -output=poly/checks -vm=python3 github.com/bebop/poly/checks

# the following is required to enable dlopen to open the _go.so file
import os,sys,inspect,collections
try:
	import collections.abc as _collections_abc
except ImportError:
	_collections_abc = collections

cwd = os.getcwd()
currentdir = os.path.dirname(os.path.abspath(inspect.getfile(inspect.currentframe())))
os.chdir(currentdir)
from . import _checks
from . import go

os.chdir(cwd)

# to use this code in your end-user python file, import it as follows:
# from checks import checks
# and then refer to everything using checks. prefix
# packages imported by this package listed below:




# ---- Types ---


#---- Enums from Go (collections of consts with same type) ---


#---- Constants from Go: Python can only ask that you please don't change these! ---


# ---- Global Variables: can only use functions to access ---


# ---- Interfaces ---


# ---- Structs ---


# ---- Slices ---


# ---- Maps ---


# ---- Constructors ---


# ---- Functions ---
def IsPalindromic(sequence):
	"""IsPalindromic(str sequence) bool
	
	IsPalindromic accepts a sequence of even length and returns if it is
	palindromic. More here - https://en.wikipedia.org/wiki/Palindromic_sequence
	"""
	return _checks.checks_IsPalindromic(sequence)
def IsRNA(seq):
	"""IsRNA(str seq) bool"""
	return _checks.checks_IsRNA(seq)
def GcContent(sequence):
	"""GcContent(str sequence) float
	
	GcContent checks the GcContent of a given sequence.
	"""
	return _checks.checks_GcContent(sequence)
def IsDNA(seq):
	"""IsDNA(str seq) bool"""
	return _checks.checks_IsDNA(seq)


