/*
cgo stubs for package genbank.
File is generated by gopy. Do not edit.
gopy build -output=poly/io/genbank -vm=python3 github.com/bebop/poly/io/genbank
*/

package main

/*

#cgo CFLAGS: "-I/opt/homebrew/opt/python@3.13/Frameworks/Python.framework/Versions/3.13/include/python3.13" -Wno-error -Wno-implicit-function-declaration -Wno-int-conversion
#cgo LDFLAGS: "-L/opt/homebrew/opt/python@3.13/Frameworks/Python.framework/Versions/3.13/lib" "-lpython3.13" -ldl  -framework CoreFoundation

// #define Py_LIMITED_API // need full API for PyRun*
#include <Python.h>
typedef uint8_t bool;
// static inline is trick for avoiding need for extra .c file
// the following are used for build value -- switch on reflect.Kind
// or the types equivalent
static inline PyObject* gopy_build_bool(uint8_t val) {
	return Py_BuildValue("b", val);
}
static inline PyObject* gopy_build_int64(int64_t val) {
	return Py_BuildValue("k", val);
}
static inline PyObject* gopy_build_uint64(uint64_t val) {
	return Py_BuildValue("K", val);
}
static inline PyObject* gopy_build_float64(double val) {
	return Py_BuildValue("d", val);
}
static inline PyObject* gopy_build_string(const char* val) {
	return Py_BuildValue("s", val);
}
static inline void gopy_decref(PyObject* obj) { // macro
	Py_XDECREF(obj);
}
static inline void gopy_incref(PyObject* obj) { // macro
	Py_XINCREF(obj);
}
static inline int gopy_method_check(PyObject* obj) { // macro
	return PyMethod_Check(obj);
}
static inline void gopy_err_handle() {
	if(PyErr_Occurred() != NULL) {
		PyErr_Print();
	}
}

*/
import "C"
import (
	"errors"
	"reflect"
	"unsafe"

	"github.com/go-python/gopy/gopyh" // handler

	"io"

	"github.com/bebop/poly/io/genbank"
)

// main doesn't do anything in lib / pkg mode, but is essential for exe mode
func main() {

}

// initialization functions -- can be called from python after library is loaded
// GoPyInitRunFile runs a separate python file -- call in GoPyInit if it
// steals the main thread e.g., for GUI event loop, as in GoGi startup.

//export GoPyInit
func GoPyInit() {

}

// type for the handle -- int64 for speed (can switch to string)
type GoHandle int64
type CGoHandle C.longlong

// DecRef decrements the reference count for the specified handle
// and deletes it it goes to zero.
//
//export DecRef
func DecRef(handle CGoHandle) {
	gopyh.DecRef(gopyh.CGoHandle(handle))
}

// IncRef increments the reference count for the specified handle.
//
//export IncRef
func IncRef(handle CGoHandle) {
	gopyh.IncRef(gopyh.CGoHandle(handle))
}

// NumHandles returns the number of handles currently in use.
//
//export NumHandles
func NumHandles() int {
	return gopyh.NumHandles()
}

// boolGoToPy converts a Go bool to python-compatible C.char
func boolGoToPy(b bool) C.char {
	if b {
		return 1
	}
	return 0
}

// boolPyToGo converts a python-compatible C.Char to Go bool
func boolPyToGo(b C.char) bool {
	if b != 0 {
		return true
	}
	return false
}

func complex64GoToPy(c complex64) *C.PyObject {
	return C.PyComplex_FromDoubles(C.double(real(c)), C.double(imag(c)))
}

func complex64PyToGo(o *C.PyObject) complex64 {
	v := C.PyComplex_AsCComplex(o)
	return complex(float32(v.real), float32(v.imag))
}

func complex128GoToPy(c complex128) *C.PyObject {
	return C.PyComplex_FromDoubles(C.double(real(c)), C.double(imag(c)))
}

func complex128PyToGo(o *C.PyObject) complex128 {
	v := C.PyComplex_AsCComplex(o)
	return complex(float64(v.real), float64(v.imag))
}

// errorGoToPy converts a Go error to python-compatible C.CString
func errorGoToPy(e error) *C.char {
	if e != nil {
		return C.CString(e.Error())
	}
	return C.CString("")
}

// --- generated code for package: genbank below: ---

// ---- External Types Outside of Targeted Packages ---

// Converters for pointer handles for type: io.Reader
func ptrFromHandle_io_Reader(h CGoHandle) io.Reader {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "io.Reader")
	if p == nil {
		return nil
	}
	return p.(io.Reader)
}
func handleFromPtr_io_Reader(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("io.Reader", p))
}

// ---- Package: go ---

// ---- Types ---

// Converters for implicit pointer handles for type: []bool
func ptrFromHandle_Slice_bool(h CGoHandle) *[]bool {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]bool")
	if p == nil {
		return nil
	}
	return p.(*[]bool)
}
func deptrFromHandle_Slice_bool(h CGoHandle) []bool {
	p := ptrFromHandle_Slice_bool(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_bool(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]bool", p))
}

// --- wrapping slice: []bool ---
//
//export Slice_bool_CTor
func Slice_bool_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_bool(&[]bool{}))
}

//export Slice_bool_len
func Slice_bool_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_bool(handle))
}

//export Slice_bool_elem
func Slice_bool_elem(handle CGoHandle, _idx int) C.char {
	s := deptrFromHandle_Slice_bool(handle)
	return boolGoToPy(s[_idx])
}

//export Slice_bool_subslice
func Slice_bool_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_bool(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_bool(&ss))
}

//export Slice_bool_set
func Slice_bool_set(handle CGoHandle, _idx int, _vl C.char) {
	s := deptrFromHandle_Slice_bool(handle)
	s[_idx] = boolPyToGo(_vl)
}

//export Slice_bool_append
func Slice_bool_append(handle CGoHandle, _vl C.char) {
	s := ptrFromHandle_Slice_bool(handle)
	*s = append(*s, boolPyToGo(_vl))
}

// Converters for implicit pointer handles for type: []byte
func ptrFromHandle_Slice_byte(h CGoHandle) *[]byte {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]byte")
	if p == nil {
		return nil
	}
	return p.(*[]byte)
}
func deptrFromHandle_Slice_byte(h CGoHandle) []byte {
	p := ptrFromHandle_Slice_byte(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_byte(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]byte", p))
}

// --- wrapping slice: []byte ---
//
//export Slice_byte_CTor
func Slice_byte_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_byte(&[]byte{}))
}

//export Slice_byte_len
func Slice_byte_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_byte(handle))
}

//export Slice_byte_elem
func Slice_byte_elem(handle CGoHandle, _idx int) C.char {
	s := deptrFromHandle_Slice_byte(handle)
	return C.char(s[_idx])
}

//export Slice_byte_subslice
func Slice_byte_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_byte(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_byte(&ss))
}

//export Slice_byte_set
func Slice_byte_set(handle CGoHandle, _idx int, _vl C.char) {
	s := deptrFromHandle_Slice_byte(handle)
	s[_idx] = byte(_vl)
}

//export Slice_byte_append
func Slice_byte_append(handle CGoHandle, _vl C.char) {
	s := ptrFromHandle_Slice_byte(handle)
	*s = append(*s, byte(_vl))
}

//export Slice_byte_from_bytes
func Slice_byte_from_bytes(o *C.PyObject) CGoHandle {
	size := C.PyBytes_Size(o)
	ptr := unsafe.Pointer(C.PyBytes_AsString(o))
	data := make([]byte, size)
	tmp := unsafe.Slice((*byte)(ptr), size)
	copy(data, tmp)
	return handleFromPtr_Slice_byte(&data)
}

//export Slice_byte_to_bytes
func Slice_byte_to_bytes(handle CGoHandle) *C.PyObject {
	s := deptrFromHandle_Slice_byte(handle)
	ptr := unsafe.Pointer(&s[0])
	size := len(s)
	return C.PyBytes_FromStringAndSize((*C.char)(ptr), C.long(size))
}

// Converters for implicit pointer handles for type: []error
func ptrFromHandle_Slice_error(h CGoHandle) *[]error {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]error")
	if p == nil {
		return nil
	}
	return p.(*[]error)
}
func deptrFromHandle_Slice_error(h CGoHandle) []error {
	p := ptrFromHandle_Slice_error(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_error(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]error", p))
}

// --- wrapping slice: []error ---
//
//export Slice_error_CTor
func Slice_error_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_error(&[]error{}))
}

//export Slice_error_len
func Slice_error_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_error(handle))
}

//export Slice_error_elem
func Slice_error_elem(handle CGoHandle, _idx int) *C.char {
	s := deptrFromHandle_Slice_error(handle)
	return errorGoToPy(s[_idx])
}

//export Slice_error_subslice
func Slice_error_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_error(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_error(&ss))
}

//export Slice_error_set
func Slice_error_set(handle CGoHandle, _idx int, _vl *C.char) {
	s := deptrFromHandle_Slice_error(handle)
	s[_idx] = errors.New(C.GoString(_vl))
}

//export Slice_error_append
func Slice_error_append(handle CGoHandle, _vl *C.char) {
	s := ptrFromHandle_Slice_error(handle)
	*s = append(*s, errors.New(C.GoString(_vl)))
}

// Converters for implicit pointer handles for type: []float32
func ptrFromHandle_Slice_float32(h CGoHandle) *[]float32 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]float32")
	if p == nil {
		return nil
	}
	return p.(*[]float32)
}
func deptrFromHandle_Slice_float32(h CGoHandle) []float32 {
	p := ptrFromHandle_Slice_float32(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_float32(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]float32", p))
}

// --- wrapping slice: []float32 ---
//
//export Slice_float32_CTor
func Slice_float32_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_float32(&[]float32{}))
}

//export Slice_float32_len
func Slice_float32_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_float32(handle))
}

//export Slice_float32_elem
func Slice_float32_elem(handle CGoHandle, _idx int) C.float {
	s := deptrFromHandle_Slice_float32(handle)
	return C.float(s[_idx])
}

//export Slice_float32_subslice
func Slice_float32_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_float32(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_float32(&ss))
}

//export Slice_float32_set
func Slice_float32_set(handle CGoHandle, _idx int, _vl C.float) {
	s := deptrFromHandle_Slice_float32(handle)
	s[_idx] = float32(_vl)
}

//export Slice_float32_append
func Slice_float32_append(handle CGoHandle, _vl C.float) {
	s := ptrFromHandle_Slice_float32(handle)
	*s = append(*s, float32(_vl))
}

// Converters for implicit pointer handles for type: []float64
func ptrFromHandle_Slice_float64(h CGoHandle) *[]float64 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]float64")
	if p == nil {
		return nil
	}
	return p.(*[]float64)
}
func deptrFromHandle_Slice_float64(h CGoHandle) []float64 {
	p := ptrFromHandle_Slice_float64(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_float64(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]float64", p))
}

// --- wrapping slice: []float64 ---
//
//export Slice_float64_CTor
func Slice_float64_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_float64(&[]float64{}))
}

//export Slice_float64_len
func Slice_float64_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_float64(handle))
}

//export Slice_float64_elem
func Slice_float64_elem(handle CGoHandle, _idx int) C.double {
	s := deptrFromHandle_Slice_float64(handle)
	return C.double(s[_idx])
}

//export Slice_float64_subslice
func Slice_float64_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_float64(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_float64(&ss))
}

//export Slice_float64_set
func Slice_float64_set(handle CGoHandle, _idx int, _vl C.double) {
	s := deptrFromHandle_Slice_float64(handle)
	s[_idx] = float64(_vl)
}

//export Slice_float64_append
func Slice_float64_append(handle CGoHandle, _vl C.double) {
	s := ptrFromHandle_Slice_float64(handle)
	*s = append(*s, float64(_vl))
}

// Converters for implicit pointer handles for type: []int
func ptrFromHandle_Slice_int(h CGoHandle) *[]int {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]int")
	if p == nil {
		return nil
	}
	return p.(*[]int)
}
func deptrFromHandle_Slice_int(h CGoHandle) []int {
	p := ptrFromHandle_Slice_int(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_int(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]int", p))
}

// --- wrapping slice: []int ---
//
//export Slice_int_CTor
func Slice_int_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_int(&[]int{}))
}

//export Slice_int_len
func Slice_int_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_int(handle))
}

//export Slice_int_elem
func Slice_int_elem(handle CGoHandle, _idx int) C.longlong {
	s := deptrFromHandle_Slice_int(handle)
	return C.longlong(s[_idx])
}

//export Slice_int_subslice
func Slice_int_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_int(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_int(&ss))
}

//export Slice_int_set
func Slice_int_set(handle CGoHandle, _idx int, _vl C.longlong) {
	s := deptrFromHandle_Slice_int(handle)
	s[_idx] = int(_vl)
}

//export Slice_int_append
func Slice_int_append(handle CGoHandle, _vl C.longlong) {
	s := ptrFromHandle_Slice_int(handle)
	*s = append(*s, int(_vl))
}

// Converters for implicit pointer handles for type: []int16
func ptrFromHandle_Slice_int16(h CGoHandle) *[]int16 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]int16")
	if p == nil {
		return nil
	}
	return p.(*[]int16)
}
func deptrFromHandle_Slice_int16(h CGoHandle) []int16 {
	p := ptrFromHandle_Slice_int16(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_int16(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]int16", p))
}

// --- wrapping slice: []int16 ---
//
//export Slice_int16_CTor
func Slice_int16_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_int16(&[]int16{}))
}

//export Slice_int16_len
func Slice_int16_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_int16(handle))
}

//export Slice_int16_elem
func Slice_int16_elem(handle CGoHandle, _idx int) C.short {
	s := deptrFromHandle_Slice_int16(handle)
	return C.short(s[_idx])
}

//export Slice_int16_subslice
func Slice_int16_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_int16(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_int16(&ss))
}

//export Slice_int16_set
func Slice_int16_set(handle CGoHandle, _idx int, _vl C.short) {
	s := deptrFromHandle_Slice_int16(handle)
	s[_idx] = int16(_vl)
}

//export Slice_int16_append
func Slice_int16_append(handle CGoHandle, _vl C.short) {
	s := ptrFromHandle_Slice_int16(handle)
	*s = append(*s, int16(_vl))
}

// Converters for implicit pointer handles for type: []int32
func ptrFromHandle_Slice_int32(h CGoHandle) *[]int32 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]int32")
	if p == nil {
		return nil
	}
	return p.(*[]int32)
}
func deptrFromHandle_Slice_int32(h CGoHandle) []int32 {
	p := ptrFromHandle_Slice_int32(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_int32(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]int32", p))
}

// --- wrapping slice: []int32 ---
//
//export Slice_int32_CTor
func Slice_int32_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_int32(&[]int32{}))
}

//export Slice_int32_len
func Slice_int32_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_int32(handle))
}

//export Slice_int32_elem
func Slice_int32_elem(handle CGoHandle, _idx int) C.long {
	s := deptrFromHandle_Slice_int32(handle)
	return C.long(s[_idx])
}

//export Slice_int32_subslice
func Slice_int32_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_int32(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_int32(&ss))
}

//export Slice_int32_set
func Slice_int32_set(handle CGoHandle, _idx int, _vl C.long) {
	s := deptrFromHandle_Slice_int32(handle)
	s[_idx] = int32(_vl)
}

//export Slice_int32_append
func Slice_int32_append(handle CGoHandle, _vl C.long) {
	s := ptrFromHandle_Slice_int32(handle)
	*s = append(*s, int32(_vl))
}

// Converters for implicit pointer handles for type: []int64
func ptrFromHandle_Slice_int64(h CGoHandle) *[]int64 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]int64")
	if p == nil {
		return nil
	}
	return p.(*[]int64)
}
func deptrFromHandle_Slice_int64(h CGoHandle) []int64 {
	p := ptrFromHandle_Slice_int64(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_int64(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]int64", p))
}

// --- wrapping slice: []int64 ---
//
//export Slice_int64_CTor
func Slice_int64_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_int64(&[]int64{}))
}

//export Slice_int64_len
func Slice_int64_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_int64(handle))
}

//export Slice_int64_elem
func Slice_int64_elem(handle CGoHandle, _idx int) C.longlong {
	s := deptrFromHandle_Slice_int64(handle)
	return C.longlong(s[_idx])
}

//export Slice_int64_subslice
func Slice_int64_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_int64(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_int64(&ss))
}

//export Slice_int64_set
func Slice_int64_set(handle CGoHandle, _idx int, _vl C.longlong) {
	s := deptrFromHandle_Slice_int64(handle)
	s[_idx] = int64(_vl)
}

//export Slice_int64_append
func Slice_int64_append(handle CGoHandle, _vl C.longlong) {
	s := ptrFromHandle_Slice_int64(handle)
	*s = append(*s, int64(_vl))
}

// Converters for implicit pointer handles for type: []int8
func ptrFromHandle_Slice_int8(h CGoHandle) *[]int8 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]int8")
	if p == nil {
		return nil
	}
	return p.(*[]int8)
}
func deptrFromHandle_Slice_int8(h CGoHandle) []int8 {
	p := ptrFromHandle_Slice_int8(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_int8(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]int8", p))
}

// --- wrapping slice: []int8 ---
//
//export Slice_int8_CTor
func Slice_int8_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_int8(&[]int8{}))
}

//export Slice_int8_len
func Slice_int8_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_int8(handle))
}

//export Slice_int8_elem
func Slice_int8_elem(handle CGoHandle, _idx int) C.char {
	s := deptrFromHandle_Slice_int8(handle)
	return C.char(s[_idx])
}

//export Slice_int8_subslice
func Slice_int8_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_int8(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_int8(&ss))
}

//export Slice_int8_set
func Slice_int8_set(handle CGoHandle, _idx int, _vl C.char) {
	s := deptrFromHandle_Slice_int8(handle)
	s[_idx] = int8(_vl)
}

//export Slice_int8_append
func Slice_int8_append(handle CGoHandle, _vl C.char) {
	s := ptrFromHandle_Slice_int8(handle)
	*s = append(*s, int8(_vl))
}

// Converters for implicit pointer handles for type: []rune
func ptrFromHandle_Slice_rune(h CGoHandle) *[]rune {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]rune")
	if p == nil {
		return nil
	}
	return p.(*[]rune)
}
func deptrFromHandle_Slice_rune(h CGoHandle) []rune {
	p := ptrFromHandle_Slice_rune(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_rune(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]rune", p))
}

// --- wrapping slice: []rune ---
//
//export Slice_rune_CTor
func Slice_rune_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_rune(&[]rune{}))
}

//export Slice_rune_len
func Slice_rune_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_rune(handle))
}

//export Slice_rune_elem
func Slice_rune_elem(handle CGoHandle, _idx int) C.long {
	s := deptrFromHandle_Slice_rune(handle)
	return C.long(s[_idx])
}

//export Slice_rune_subslice
func Slice_rune_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_rune(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_rune(&ss))
}

//export Slice_rune_set
func Slice_rune_set(handle CGoHandle, _idx int, _vl C.long) {
	s := deptrFromHandle_Slice_rune(handle)
	s[_idx] = rune(_vl)
}

//export Slice_rune_append
func Slice_rune_append(handle CGoHandle, _vl C.long) {
	s := ptrFromHandle_Slice_rune(handle)
	*s = append(*s, rune(_vl))
}

// Converters for implicit pointer handles for type: []string
func ptrFromHandle_Slice_string(h CGoHandle) *[]string {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]string")
	if p == nil {
		return nil
	}
	return p.(*[]string)
}
func deptrFromHandle_Slice_string(h CGoHandle) []string {
	p := ptrFromHandle_Slice_string(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_string(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]string", p))
}

// --- wrapping slice: []string ---
//
//export Slice_string_CTor
func Slice_string_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_string(&[]string{}))
}

//export Slice_string_len
func Slice_string_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_string(handle))
}

//export Slice_string_elem
func Slice_string_elem(handle CGoHandle, _idx int) *C.char {
	s := deptrFromHandle_Slice_string(handle)
	return C.CString(s[_idx])
}

//export Slice_string_subslice
func Slice_string_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_string(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_string(&ss))
}

//export Slice_string_set
func Slice_string_set(handle CGoHandle, _idx int, _vl *C.char) {
	s := deptrFromHandle_Slice_string(handle)
	s[_idx] = C.GoString(_vl)
}

//export Slice_string_append
func Slice_string_append(handle CGoHandle, _vl *C.char) {
	s := ptrFromHandle_Slice_string(handle)
	*s = append(*s, C.GoString(_vl))
}

// Converters for implicit pointer handles for type: []uint
func ptrFromHandle_Slice_uint(h CGoHandle) *[]uint {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]uint")
	if p == nil {
		return nil
	}
	return p.(*[]uint)
}
func deptrFromHandle_Slice_uint(h CGoHandle) []uint {
	p := ptrFromHandle_Slice_uint(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_uint(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]uint", p))
}

// --- wrapping slice: []uint ---
//
//export Slice_uint_CTor
func Slice_uint_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_uint(&[]uint{}))
}

//export Slice_uint_len
func Slice_uint_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_uint(handle))
}

//export Slice_uint_elem
func Slice_uint_elem(handle CGoHandle, _idx int) C.ulonglong {
	s := deptrFromHandle_Slice_uint(handle)
	return C.ulonglong(s[_idx])
}

//export Slice_uint_subslice
func Slice_uint_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_uint(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_uint(&ss))
}

//export Slice_uint_set
func Slice_uint_set(handle CGoHandle, _idx int, _vl C.ulonglong) {
	s := deptrFromHandle_Slice_uint(handle)
	s[_idx] = uint(_vl)
}

//export Slice_uint_append
func Slice_uint_append(handle CGoHandle, _vl C.ulonglong) {
	s := ptrFromHandle_Slice_uint(handle)
	*s = append(*s, uint(_vl))
}

// Converters for implicit pointer handles for type: []uint16
func ptrFromHandle_Slice_uint16(h CGoHandle) *[]uint16 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]uint16")
	if p == nil {
		return nil
	}
	return p.(*[]uint16)
}
func deptrFromHandle_Slice_uint16(h CGoHandle) []uint16 {
	p := ptrFromHandle_Slice_uint16(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_uint16(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]uint16", p))
}

// --- wrapping slice: []uint16 ---
//
//export Slice_uint16_CTor
func Slice_uint16_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_uint16(&[]uint16{}))
}

//export Slice_uint16_len
func Slice_uint16_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_uint16(handle))
}

//export Slice_uint16_elem
func Slice_uint16_elem(handle CGoHandle, _idx int) C.ushort {
	s := deptrFromHandle_Slice_uint16(handle)
	return C.ushort(s[_idx])
}

//export Slice_uint16_subslice
func Slice_uint16_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_uint16(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_uint16(&ss))
}

//export Slice_uint16_set
func Slice_uint16_set(handle CGoHandle, _idx int, _vl C.ushort) {
	s := deptrFromHandle_Slice_uint16(handle)
	s[_idx] = uint16(_vl)
}

//export Slice_uint16_append
func Slice_uint16_append(handle CGoHandle, _vl C.ushort) {
	s := ptrFromHandle_Slice_uint16(handle)
	*s = append(*s, uint16(_vl))
}

// Converters for implicit pointer handles for type: []uint32
func ptrFromHandle_Slice_uint32(h CGoHandle) *[]uint32 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]uint32")
	if p == nil {
		return nil
	}
	return p.(*[]uint32)
}
func deptrFromHandle_Slice_uint32(h CGoHandle) []uint32 {
	p := ptrFromHandle_Slice_uint32(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_uint32(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]uint32", p))
}

// --- wrapping slice: []uint32 ---
//
//export Slice_uint32_CTor
func Slice_uint32_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_uint32(&[]uint32{}))
}

//export Slice_uint32_len
func Slice_uint32_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_uint32(handle))
}

//export Slice_uint32_elem
func Slice_uint32_elem(handle CGoHandle, _idx int) C.ulong {
	s := deptrFromHandle_Slice_uint32(handle)
	return C.ulong(s[_idx])
}

//export Slice_uint32_subslice
func Slice_uint32_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_uint32(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_uint32(&ss))
}

//export Slice_uint32_set
func Slice_uint32_set(handle CGoHandle, _idx int, _vl C.ulong) {
	s := deptrFromHandle_Slice_uint32(handle)
	s[_idx] = uint32(_vl)
}

//export Slice_uint32_append
func Slice_uint32_append(handle CGoHandle, _vl C.ulong) {
	s := ptrFromHandle_Slice_uint32(handle)
	*s = append(*s, uint32(_vl))
}

// Converters for implicit pointer handles for type: []uint64
func ptrFromHandle_Slice_uint64(h CGoHandle) *[]uint64 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]uint64")
	if p == nil {
		return nil
	}
	return p.(*[]uint64)
}
func deptrFromHandle_Slice_uint64(h CGoHandle) []uint64 {
	p := ptrFromHandle_Slice_uint64(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_uint64(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]uint64", p))
}

// --- wrapping slice: []uint64 ---
//
//export Slice_uint64_CTor
func Slice_uint64_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_uint64(&[]uint64{}))
}

//export Slice_uint64_len
func Slice_uint64_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_uint64(handle))
}

//export Slice_uint64_elem
func Slice_uint64_elem(handle CGoHandle, _idx int) C.ulonglong {
	s := deptrFromHandle_Slice_uint64(handle)
	return C.ulonglong(s[_idx])
}

//export Slice_uint64_subslice
func Slice_uint64_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_uint64(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_uint64(&ss))
}

//export Slice_uint64_set
func Slice_uint64_set(handle CGoHandle, _idx int, _vl C.ulonglong) {
	s := deptrFromHandle_Slice_uint64(handle)
	s[_idx] = uint64(_vl)
}

//export Slice_uint64_append
func Slice_uint64_append(handle CGoHandle, _vl C.ulonglong) {
	s := ptrFromHandle_Slice_uint64(handle)
	*s = append(*s, uint64(_vl))
}

// Converters for implicit pointer handles for type: []uint8
func ptrFromHandle_Slice_uint8(h CGoHandle) *[]uint8 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]uint8")
	if p == nil {
		return nil
	}
	return p.(*[]uint8)
}
func deptrFromHandle_Slice_uint8(h CGoHandle) []uint8 {
	p := ptrFromHandle_Slice_uint8(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_uint8(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]uint8", p))
}

// --- wrapping slice: []uint8 ---
//
//export Slice_uint8_CTor
func Slice_uint8_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_uint8(&[]uint8{}))
}

//export Slice_uint8_len
func Slice_uint8_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_uint8(handle))
}

//export Slice_uint8_elem
func Slice_uint8_elem(handle CGoHandle, _idx int) C.uchar {
	s := deptrFromHandle_Slice_uint8(handle)
	return C.uchar(s[_idx])
}

//export Slice_uint8_subslice
func Slice_uint8_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_uint8(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_uint8(&ss))
}

//export Slice_uint8_set
func Slice_uint8_set(handle CGoHandle, _idx int, _vl C.uchar) {
	s := deptrFromHandle_Slice_uint8(handle)
	s[_idx] = uint8(_vl)
}

//export Slice_uint8_append
func Slice_uint8_append(handle CGoHandle, _vl C.uchar) {
	s := ptrFromHandle_Slice_uint8(handle)
	*s = append(*s, uint8(_vl))
}

// ---- Package: genbank ---

// ---- Types ---

// Converters for pointer handles for type: *genbank.BaseCount
func ptrFromHandle_Ptr_genbank_BaseCount(h CGoHandle) *genbank.BaseCount {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "*genbank.BaseCount")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.BaseCount{})).(*genbank.BaseCount)
}
func handleFromPtr_Ptr_genbank_BaseCount(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("*genbank.BaseCount", p))
}

// Converters for pointer handles for type: *genbank.Feature
func ptrFromHandle_Ptr_genbank_Feature(h CGoHandle) *genbank.Feature {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "*genbank.Feature")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Feature{})).(*genbank.Feature)
}
func handleFromPtr_Ptr_genbank_Feature(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("*genbank.Feature", p))
}

// Converters for pointer handles for type: *genbank.Genbank
func ptrFromHandle_Ptr_genbank_Genbank(h CGoHandle) *genbank.Genbank {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "*genbank.Genbank")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Genbank{})).(*genbank.Genbank)
}
func handleFromPtr_Ptr_genbank_Genbank(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("*genbank.Genbank", p))
}

// Converters for pointer handles for type: *genbank.Location
func ptrFromHandle_Ptr_genbank_Location(h CGoHandle) *genbank.Location {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "*genbank.Location")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Location{})).(*genbank.Location)
}
func handleFromPtr_Ptr_genbank_Location(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("*genbank.Location", p))
}

// Converters for pointer handles for type: *genbank.Locus
func ptrFromHandle_Ptr_genbank_Locus(h CGoHandle) *genbank.Locus {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "*genbank.Locus")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Locus{})).(*genbank.Locus)
}
func handleFromPtr_Ptr_genbank_Locus(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("*genbank.Locus", p))
}

// Converters for pointer handles for type: *genbank.Meta
func ptrFromHandle_Ptr_genbank_Meta(h CGoHandle) *genbank.Meta {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "*genbank.Meta")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Meta{})).(*genbank.Meta)
}
func handleFromPtr_Ptr_genbank_Meta(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("*genbank.Meta", p))
}

// Converters for pointer handles for type: *genbank.Reference
func ptrFromHandle_Ptr_genbank_Reference(h CGoHandle) *genbank.Reference {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "*genbank.Reference")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Reference{})).(*genbank.Reference)
}
func handleFromPtr_Ptr_genbank_Reference(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("*genbank.Reference", p))
}

// Converters for implicit pointer handles for type: []genbank.BaseCount
func ptrFromHandle_Slice_genbank_BaseCount(h CGoHandle) *[]genbank.BaseCount {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]genbank.BaseCount")
	if p == nil {
		return nil
	}
	return p.(*[]genbank.BaseCount)
}
func deptrFromHandle_Slice_genbank_BaseCount(h CGoHandle) []genbank.BaseCount {
	p := ptrFromHandle_Slice_genbank_BaseCount(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_genbank_BaseCount(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]genbank.BaseCount", p))
}

// --- wrapping slice: []genbank.BaseCount ---
//
//export Slice_genbank_BaseCount_CTor
func Slice_genbank_BaseCount_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_genbank_BaseCount(&[]genbank.BaseCount{}))
}

//export Slice_genbank_BaseCount_len
func Slice_genbank_BaseCount_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_genbank_BaseCount(handle))
}

//export Slice_genbank_BaseCount_elem
func Slice_genbank_BaseCount_elem(handle CGoHandle, _idx int) CGoHandle {
	s := deptrFromHandle_Slice_genbank_BaseCount(handle)
	return handleFromPtr_genbank_BaseCount(&(s[_idx]))
}

//export Slice_genbank_BaseCount_subslice
func Slice_genbank_BaseCount_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_genbank_BaseCount(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_genbank_BaseCount(&ss))
}

//export Slice_genbank_BaseCount_set
func Slice_genbank_BaseCount_set(handle CGoHandle, _idx int, _vl CGoHandle) {
	s := deptrFromHandle_Slice_genbank_BaseCount(handle)
	s[_idx] = *ptrFromHandle_genbank_BaseCount(_vl)
}

//export Slice_genbank_BaseCount_append
func Slice_genbank_BaseCount_append(handle CGoHandle, _vl CGoHandle) {
	s := ptrFromHandle_Slice_genbank_BaseCount(handle)
	*s = append(*s, *ptrFromHandle_genbank_BaseCount(_vl))
}

// Converters for implicit pointer handles for type: []genbank.Feature
func ptrFromHandle_Slice_genbank_Feature(h CGoHandle) *[]genbank.Feature {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]genbank.Feature")
	if p == nil {
		return nil
	}
	return p.(*[]genbank.Feature)
}
func deptrFromHandle_Slice_genbank_Feature(h CGoHandle) []genbank.Feature {
	p := ptrFromHandle_Slice_genbank_Feature(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_genbank_Feature(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]genbank.Feature", p))
}

// --- wrapping slice: []genbank.Feature ---
//
//export Slice_genbank_Feature_CTor
func Slice_genbank_Feature_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_genbank_Feature(&[]genbank.Feature{}))
}

//export Slice_genbank_Feature_len
func Slice_genbank_Feature_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_genbank_Feature(handle))
}

//export Slice_genbank_Feature_elem
func Slice_genbank_Feature_elem(handle CGoHandle, _idx int) CGoHandle {
	s := deptrFromHandle_Slice_genbank_Feature(handle)
	return handleFromPtr_genbank_Feature(&(s[_idx]))
}

//export Slice_genbank_Feature_subslice
func Slice_genbank_Feature_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_genbank_Feature(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_genbank_Feature(&ss))
}

//export Slice_genbank_Feature_set
func Slice_genbank_Feature_set(handle CGoHandle, _idx int, _vl CGoHandle) {
	s := deptrFromHandle_Slice_genbank_Feature(handle)
	s[_idx] = *ptrFromHandle_genbank_Feature(_vl)
}

//export Slice_genbank_Feature_append
func Slice_genbank_Feature_append(handle CGoHandle, _vl CGoHandle) {
	s := ptrFromHandle_Slice_genbank_Feature(handle)
	*s = append(*s, *ptrFromHandle_genbank_Feature(_vl))
}

// Converters for implicit pointer handles for type: []genbank.Genbank
func ptrFromHandle_Slice_genbank_Genbank(h CGoHandle) *[]genbank.Genbank {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]genbank.Genbank")
	if p == nil {
		return nil
	}
	return p.(*[]genbank.Genbank)
}
func deptrFromHandle_Slice_genbank_Genbank(h CGoHandle) []genbank.Genbank {
	p := ptrFromHandle_Slice_genbank_Genbank(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_genbank_Genbank(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]genbank.Genbank", p))
}

// --- wrapping slice: []genbank.Genbank ---
//
//export Slice_genbank_Genbank_CTor
func Slice_genbank_Genbank_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_genbank_Genbank(&[]genbank.Genbank{}))
}

//export Slice_genbank_Genbank_len
func Slice_genbank_Genbank_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_genbank_Genbank(handle))
}

//export Slice_genbank_Genbank_elem
func Slice_genbank_Genbank_elem(handle CGoHandle, _idx int) CGoHandle {
	s := deptrFromHandle_Slice_genbank_Genbank(handle)
	return handleFromPtr_genbank_Genbank(&(s[_idx]))
}

//export Slice_genbank_Genbank_subslice
func Slice_genbank_Genbank_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_genbank_Genbank(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_genbank_Genbank(&ss))
}

//export Slice_genbank_Genbank_set
func Slice_genbank_Genbank_set(handle CGoHandle, _idx int, _vl CGoHandle) {
	s := deptrFromHandle_Slice_genbank_Genbank(handle)
	s[_idx] = *ptrFromHandle_genbank_Genbank(_vl)
}

//export Slice_genbank_Genbank_append
func Slice_genbank_Genbank_append(handle CGoHandle, _vl CGoHandle) {
	s := ptrFromHandle_Slice_genbank_Genbank(handle)
	*s = append(*s, *ptrFromHandle_genbank_Genbank(_vl))
}

// Converters for implicit pointer handles for type: []genbank.Location
func ptrFromHandle_Slice_genbank_Location(h CGoHandle) *[]genbank.Location {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]genbank.Location")
	if p == nil {
		return nil
	}
	return p.(*[]genbank.Location)
}
func deptrFromHandle_Slice_genbank_Location(h CGoHandle) []genbank.Location {
	p := ptrFromHandle_Slice_genbank_Location(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_genbank_Location(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]genbank.Location", p))
}

// --- wrapping slice: []genbank.Location ---
//
//export Slice_genbank_Location_CTor
func Slice_genbank_Location_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_genbank_Location(&[]genbank.Location{}))
}

//export Slice_genbank_Location_len
func Slice_genbank_Location_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_genbank_Location(handle))
}

//export Slice_genbank_Location_elem
func Slice_genbank_Location_elem(handle CGoHandle, _idx int) CGoHandle {
	s := deptrFromHandle_Slice_genbank_Location(handle)
	return handleFromPtr_genbank_Location(&(s[_idx]))
}

//export Slice_genbank_Location_subslice
func Slice_genbank_Location_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_genbank_Location(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_genbank_Location(&ss))
}

//export Slice_genbank_Location_set
func Slice_genbank_Location_set(handle CGoHandle, _idx int, _vl CGoHandle) {
	s := deptrFromHandle_Slice_genbank_Location(handle)
	s[_idx] = *ptrFromHandle_genbank_Location(_vl)
}

//export Slice_genbank_Location_append
func Slice_genbank_Location_append(handle CGoHandle, _vl CGoHandle) {
	s := ptrFromHandle_Slice_genbank_Location(handle)
	*s = append(*s, *ptrFromHandle_genbank_Location(_vl))
}

// Converters for implicit pointer handles for type: []genbank.Reference
func ptrFromHandle_Slice_genbank_Reference(h CGoHandle) *[]genbank.Reference {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]genbank.Reference")
	if p == nil {
		return nil
	}
	return p.(*[]genbank.Reference)
}
func deptrFromHandle_Slice_genbank_Reference(h CGoHandle) []genbank.Reference {
	p := ptrFromHandle_Slice_genbank_Reference(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_genbank_Reference(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]genbank.Reference", p))
}

// --- wrapping slice: []genbank.Reference ---
//
//export Slice_genbank_Reference_CTor
func Slice_genbank_Reference_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_genbank_Reference(&[]genbank.Reference{}))
}

//export Slice_genbank_Reference_len
func Slice_genbank_Reference_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_genbank_Reference(handle))
}

//export Slice_genbank_Reference_elem
func Slice_genbank_Reference_elem(handle CGoHandle, _idx int) CGoHandle {
	s := deptrFromHandle_Slice_genbank_Reference(handle)
	return handleFromPtr_genbank_Reference(&(s[_idx]))
}

//export Slice_genbank_Reference_subslice
func Slice_genbank_Reference_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_genbank_Reference(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_genbank_Reference(&ss))
}

//export Slice_genbank_Reference_set
func Slice_genbank_Reference_set(handle CGoHandle, _idx int, _vl CGoHandle) {
	s := deptrFromHandle_Slice_genbank_Reference(handle)
	s[_idx] = *ptrFromHandle_genbank_Reference(_vl)
}

//export Slice_genbank_Reference_append
func Slice_genbank_Reference_append(handle CGoHandle, _vl CGoHandle) {
	s := ptrFromHandle_Slice_genbank_Reference(handle)
	*s = append(*s, *ptrFromHandle_genbank_Reference(_vl))
}

// Converters for non-pointer handles for type: genbank.BaseCount
func ptrFromHandle_genbank_BaseCount(h CGoHandle) *genbank.BaseCount {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "genbank.BaseCount")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.BaseCount{})).(*genbank.BaseCount)
}
func handleFromPtr_genbank_BaseCount(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("genbank.BaseCount", p))
}

// Converters for non-pointer handles for type: genbank.Feature
func ptrFromHandle_genbank_Feature(h CGoHandle) *genbank.Feature {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "genbank.Feature")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Feature{})).(*genbank.Feature)
}
func handleFromPtr_genbank_Feature(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("genbank.Feature", p))
}

// Converters for non-pointer handles for type: genbank.Genbank
func ptrFromHandle_genbank_Genbank(h CGoHandle) *genbank.Genbank {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "genbank.Genbank")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Genbank{})).(*genbank.Genbank)
}
func handleFromPtr_genbank_Genbank(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("genbank.Genbank", p))
}

// Converters for non-pointer handles for type: genbank.Location
func ptrFromHandle_genbank_Location(h CGoHandle) *genbank.Location {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "genbank.Location")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Location{})).(*genbank.Location)
}
func handleFromPtr_genbank_Location(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("genbank.Location", p))
}

// Converters for non-pointer handles for type: genbank.Locus
func ptrFromHandle_genbank_Locus(h CGoHandle) *genbank.Locus {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "genbank.Locus")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Locus{})).(*genbank.Locus)
}
func handleFromPtr_genbank_Locus(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("genbank.Locus", p))
}

// Converters for non-pointer handles for type: genbank.Meta
func ptrFromHandle_genbank_Meta(h CGoHandle) *genbank.Meta {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "genbank.Meta")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Meta{})).(*genbank.Meta)
}
func handleFromPtr_genbank_Meta(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("genbank.Meta", p))
}

// Converters for non-pointer handles for type: genbank.Reference
func ptrFromHandle_genbank_Reference(h CGoHandle) *genbank.Reference {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "genbank.Reference")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Reference{})).(*genbank.Reference)
}
func handleFromPtr_genbank_Reference(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("genbank.Reference", p))
}

// Converters for implicit pointer handles for type: map[string]string
func ptrFromHandle_Map_string_string(h CGoHandle) *map[string]string {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "map[string]string")
	if p == nil {
		return nil
	}
	return p.(*map[string]string)
}
func deptrFromHandle_Map_string_string(h CGoHandle) map[string]string {
	p := ptrFromHandle_Map_string_string(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Map_string_string(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("map[string]string", p))
}

// --- wrapping map: map[string]string ---
//
//export Map_string_string_CTor
func Map_string_string_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Map_string_string(&map[string]string{}))
}

//export Map_string_string_len
func Map_string_string_len(handle CGoHandle) int {
	return len(deptrFromHandle_Map_string_string(handle))
}

//export Map_string_string_elem
func Map_string_string_elem(handle CGoHandle, _ky *C.char) *C.char {
	s := deptrFromHandle_Map_string_string(handle)
	v, ok := s[C.GoString(_ky)]
	if !ok {
		C.PyErr_SetString(C.PyExc_KeyError, C.CString("key not in map"))
	}
	return C.CString(v)
}

//export Map_string_string_contains
func Map_string_string_contains(handle CGoHandle, _ky *C.char) C.char {
	s := deptrFromHandle_Map_string_string(handle)
	_, ok := s[C.GoString(_ky)]
	return boolGoToPy(ok)
}

//export Map_string_string_set
func Map_string_string_set(handle CGoHandle, _ky *C.char, _vl *C.char) {
	s := deptrFromHandle_Map_string_string(handle)
	s[C.GoString(_ky)] = C.GoString(_vl)
}

//export Map_string_string_delete
func Map_string_string_delete(handle CGoHandle, _ky *C.char) {
	s := deptrFromHandle_Map_string_string(handle)
	delete(s, C.GoString(_ky))
}

//export Map_string_string_keys
func Map_string_string_keys(handle CGoHandle) CGoHandle {
	s := deptrFromHandle_Map_string_string(handle)
	kys := make([]string, 0, len(s))
	for k := range s {
		kys = append(kys, k)
	}
	return handleFromPtr_Slice_string(&kys)
}

// ---- Global Variables: can only use functions to access ---

// ---- Interfaces ---

// ---- Structs ---

// --- wrapping struct: genbank.Locus ---
//
//export genbank_Locus_CTor
func genbank_Locus_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_genbank_Locus(&genbank.Locus{}))
}

//export genbank_Locus_Name_Get
func genbank_Locus_Name_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Locus(handle)
	return C.CString(op.Name)
}

//export genbank_Locus_Name_Set
func genbank_Locus_Name_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Locus(handle)
	op.Name = C.GoString(val)
}

//export genbank_Locus_SequenceLength_Get
func genbank_Locus_SequenceLength_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Locus(handle)
	return C.CString(op.SequenceLength)
}

//export genbank_Locus_SequenceLength_Set
func genbank_Locus_SequenceLength_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Locus(handle)
	op.SequenceLength = C.GoString(val)
}

//export genbank_Locus_MoleculeType_Get
func genbank_Locus_MoleculeType_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Locus(handle)
	return C.CString(op.MoleculeType)
}

//export genbank_Locus_MoleculeType_Set
func genbank_Locus_MoleculeType_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Locus(handle)
	op.MoleculeType = C.GoString(val)
}

//export genbank_Locus_GenbankDivision_Get
func genbank_Locus_GenbankDivision_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Locus(handle)
	return C.CString(op.GenbankDivision)
}

//export genbank_Locus_GenbankDivision_Set
func genbank_Locus_GenbankDivision_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Locus(handle)
	op.GenbankDivision = C.GoString(val)
}

//export genbank_Locus_ModificationDate_Get
func genbank_Locus_ModificationDate_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Locus(handle)
	return C.CString(op.ModificationDate)
}

//export genbank_Locus_ModificationDate_Set
func genbank_Locus_ModificationDate_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Locus(handle)
	op.ModificationDate = C.GoString(val)
}

//export genbank_Locus_SequenceCoding_Get
func genbank_Locus_SequenceCoding_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Locus(handle)
	return C.CString(op.SequenceCoding)
}

//export genbank_Locus_SequenceCoding_Set
func genbank_Locus_SequenceCoding_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Locus(handle)
	op.SequenceCoding = C.GoString(val)
}

//export genbank_Locus_Circular_Get
func genbank_Locus_Circular_Get(handle CGoHandle) C.char {
	op := ptrFromHandle_genbank_Locus(handle)
	return boolGoToPy(op.Circular)
}

//export genbank_Locus_Circular_Set
func genbank_Locus_Circular_Set(handle CGoHandle, val C.char) {
	op := ptrFromHandle_genbank_Locus(handle)
	op.Circular = boolPyToGo(val)
}

// --- wrapping struct: genbank.Meta ---
//
//export genbank_Meta_CTor
func genbank_Meta_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_genbank_Meta(&genbank.Meta{}))
}

//export genbank_Meta_Date_Get
func genbank_Meta_Date_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Meta(handle)
	return C.CString(op.Date)
}

//export genbank_Meta_Date_Set
func genbank_Meta_Date_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Meta(handle)
	op.Date = C.GoString(val)
}

//export genbank_Meta_Definition_Get
func genbank_Meta_Definition_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Meta(handle)
	return C.CString(op.Definition)
}

//export genbank_Meta_Definition_Set
func genbank_Meta_Definition_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Meta(handle)
	op.Definition = C.GoString(val)
}

//export genbank_Meta_Accession_Get
func genbank_Meta_Accession_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Meta(handle)
	return C.CString(op.Accession)
}

//export genbank_Meta_Accession_Set
func genbank_Meta_Accession_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Meta(handle)
	op.Accession = C.GoString(val)
}

//export genbank_Meta_Version_Get
func genbank_Meta_Version_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Meta(handle)
	return C.CString(op.Version)
}

//export genbank_Meta_Version_Set
func genbank_Meta_Version_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Meta(handle)
	op.Version = C.GoString(val)
}

//export genbank_Meta_Keywords_Get
func genbank_Meta_Keywords_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Meta(handle)
	return C.CString(op.Keywords)
}

//export genbank_Meta_Keywords_Set
func genbank_Meta_Keywords_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Meta(handle)
	op.Keywords = C.GoString(val)
}

//export genbank_Meta_Organism_Get
func genbank_Meta_Organism_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Meta(handle)
	return C.CString(op.Organism)
}

//export genbank_Meta_Organism_Set
func genbank_Meta_Organism_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Meta(handle)
	op.Organism = C.GoString(val)
}

//export genbank_Meta_Source_Get
func genbank_Meta_Source_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Meta(handle)
	return C.CString(op.Source)
}

//export genbank_Meta_Source_Set
func genbank_Meta_Source_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Meta(handle)
	op.Source = C.GoString(val)
}

//export genbank_Meta_Taxonomy_Get
func genbank_Meta_Taxonomy_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_genbank_Meta(handle)
	return handleFromPtr_Slice_string(&op.Taxonomy)
}

//export genbank_Meta_Taxonomy_Set
func genbank_Meta_Taxonomy_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_genbank_Meta(handle)
	op.Taxonomy = deptrFromHandle_Slice_string(val)
}

//export genbank_Meta_Origin_Get
func genbank_Meta_Origin_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Meta(handle)
	return C.CString(op.Origin)
}

//export genbank_Meta_Origin_Set
func genbank_Meta_Origin_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Meta(handle)
	op.Origin = C.GoString(val)
}

//export genbank_Meta_Locus_Get
func genbank_Meta_Locus_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_genbank_Meta(handle)
	return handleFromPtr_genbank_Locus(&op.Locus)
}

//export genbank_Meta_Locus_Set
func genbank_Meta_Locus_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_genbank_Meta(handle)
	op.Locus = *ptrFromHandle_genbank_Locus(val)
}

//export genbank_Meta_References_Get
func genbank_Meta_References_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_genbank_Meta(handle)
	return handleFromPtr_Slice_genbank_Reference(&op.References)
}

//export genbank_Meta_References_Set
func genbank_Meta_References_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_genbank_Meta(handle)
	op.References = deptrFromHandle_Slice_genbank_Reference(val)
}

//export genbank_Meta_BaseCount_Get
func genbank_Meta_BaseCount_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_genbank_Meta(handle)
	return handleFromPtr_Slice_genbank_BaseCount(&op.BaseCount)
}

//export genbank_Meta_BaseCount_Set
func genbank_Meta_BaseCount_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_genbank_Meta(handle)
	op.BaseCount = deptrFromHandle_Slice_genbank_BaseCount(val)
}

//export genbank_Meta_Other_Get
func genbank_Meta_Other_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_genbank_Meta(handle)
	return handleFromPtr_Map_string_string(&op.Other)
}

//export genbank_Meta_Other_Set
func genbank_Meta_Other_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_genbank_Meta(handle)
	op.Other = deptrFromHandle_Map_string_string(val)
}

//export genbank_Meta_Name_Get
func genbank_Meta_Name_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Meta(handle)
	return C.CString(op.Name)
}

//export genbank_Meta_Name_Set
func genbank_Meta_Name_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Meta(handle)
	op.Name = C.GoString(val)
}

//export genbank_Meta_SequenceHash_Get
func genbank_Meta_SequenceHash_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Meta(handle)
	return C.CString(op.SequenceHash)
}

//export genbank_Meta_SequenceHash_Set
func genbank_Meta_SequenceHash_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Meta(handle)
	op.SequenceHash = C.GoString(val)
}

//export genbank_Meta_SequenceHashFunction_Get
func genbank_Meta_SequenceHashFunction_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Meta(handle)
	return C.CString(op.SequenceHashFunction)
}

//export genbank_Meta_SequenceHashFunction_Set
func genbank_Meta_SequenceHashFunction_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Meta(handle)
	op.SequenceHashFunction = C.GoString(val)
}

// --- wrapping struct: genbank.Reference ---
//
//export genbank_Reference_CTor
func genbank_Reference_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_genbank_Reference(&genbank.Reference{}))
}

//export genbank_Reference_Authors_Get
func genbank_Reference_Authors_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Reference(handle)
	return C.CString(op.Authors)
}

//export genbank_Reference_Authors_Set
func genbank_Reference_Authors_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Reference(handle)
	op.Authors = C.GoString(val)
}

//export genbank_Reference_Title_Get
func genbank_Reference_Title_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Reference(handle)
	return C.CString(op.Title)
}

//export genbank_Reference_Title_Set
func genbank_Reference_Title_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Reference(handle)
	op.Title = C.GoString(val)
}

//export genbank_Reference_Journal_Get
func genbank_Reference_Journal_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Reference(handle)
	return C.CString(op.Journal)
}

//export genbank_Reference_Journal_Set
func genbank_Reference_Journal_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Reference(handle)
	op.Journal = C.GoString(val)
}

//export genbank_Reference_PubMed_Get
func genbank_Reference_PubMed_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Reference(handle)
	return C.CString(op.PubMed)
}

//export genbank_Reference_PubMed_Set
func genbank_Reference_PubMed_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Reference(handle)
	op.PubMed = C.GoString(val)
}

//export genbank_Reference_Remark_Get
func genbank_Reference_Remark_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Reference(handle)
	return C.CString(op.Remark)
}

//export genbank_Reference_Remark_Set
func genbank_Reference_Remark_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Reference(handle)
	op.Remark = C.GoString(val)
}

//export genbank_Reference_Range_Get
func genbank_Reference_Range_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Reference(handle)
	return C.CString(op.Range)
}

//export genbank_Reference_Range_Set
func genbank_Reference_Range_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Reference(handle)
	op.Range = C.GoString(val)
}

//export genbank_Reference_Consortium_Get
func genbank_Reference_Consortium_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Reference(handle)
	return C.CString(op.Consortium)
}

//export genbank_Reference_Consortium_Set
func genbank_Reference_Consortium_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Reference(handle)
	op.Consortium = C.GoString(val)
}

// --- wrapping struct: genbank.BaseCount ---
//
//export genbank_BaseCount_CTor
func genbank_BaseCount_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_genbank_BaseCount(&genbank.BaseCount{}))
}

//export genbank_BaseCount_Base_Get
func genbank_BaseCount_Base_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_BaseCount(handle)
	return C.CString(op.Base)
}

//export genbank_BaseCount_Base_Set
func genbank_BaseCount_Base_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_BaseCount(handle)
	op.Base = C.GoString(val)
}

//export genbank_BaseCount_Count_Get
func genbank_BaseCount_Count_Get(handle CGoHandle) C.longlong {
	op := ptrFromHandle_genbank_BaseCount(handle)
	return C.longlong(op.Count)
}

//export genbank_BaseCount_Count_Set
func genbank_BaseCount_Count_Set(handle CGoHandle, val C.longlong) {
	op := ptrFromHandle_genbank_BaseCount(handle)
	op.Count = int(val)
}

// --- wrapping struct: genbank.Feature ---
//
//export genbank_Feature_CTor
func genbank_Feature_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_genbank_Feature(&genbank.Feature{}))
}

//export genbank_Feature_Type_Get
func genbank_Feature_Type_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Feature(handle)
	return C.CString(op.Type)
}

//export genbank_Feature_Type_Set
func genbank_Feature_Type_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Feature(handle)
	op.Type = C.GoString(val)
}

//export genbank_Feature_Description_Get
func genbank_Feature_Description_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Feature(handle)
	return C.CString(op.Description)
}

//export genbank_Feature_Description_Set
func genbank_Feature_Description_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Feature(handle)
	op.Description = C.GoString(val)
}

//export genbank_Feature_Attributes_Get
func genbank_Feature_Attributes_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_genbank_Feature(handle)
	return handleFromPtr_Map_string_string(&op.Attributes)
}

//export genbank_Feature_Attributes_Set
func genbank_Feature_Attributes_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_genbank_Feature(handle)
	op.Attributes = deptrFromHandle_Map_string_string(val)
}

//export genbank_Feature_SequenceHash_Get
func genbank_Feature_SequenceHash_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Feature(handle)
	return C.CString(op.SequenceHash)
}

//export genbank_Feature_SequenceHash_Set
func genbank_Feature_SequenceHash_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Feature(handle)
	op.SequenceHash = C.GoString(val)
}

//export genbank_Feature_SequenceHashFunction_Get
func genbank_Feature_SequenceHashFunction_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Feature(handle)
	return C.CString(op.SequenceHashFunction)
}

//export genbank_Feature_SequenceHashFunction_Set
func genbank_Feature_SequenceHashFunction_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Feature(handle)
	op.SequenceHashFunction = C.GoString(val)
}

//export genbank_Feature_Sequence_Get
func genbank_Feature_Sequence_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Feature(handle)
	return C.CString(op.Sequence)
}

//export genbank_Feature_Sequence_Set
func genbank_Feature_Sequence_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Feature(handle)
	op.Sequence = C.GoString(val)
}

//export genbank_Feature_Location_Get
func genbank_Feature_Location_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_genbank_Feature(handle)
	return handleFromPtr_genbank_Location(&op.Location)
}

//export genbank_Feature_Location_Set
func genbank_Feature_Location_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_genbank_Feature(handle)
	op.Location = *ptrFromHandle_genbank_Location(val)
}

//export genbank_Feature_ParentSequence_Get
func genbank_Feature_ParentSequence_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_genbank_Feature(handle)
	return handleFromPtr_Ptr_genbank_Genbank(op.ParentSequence)
}

//export genbank_Feature_ParentSequence_Set
func genbank_Feature_ParentSequence_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_genbank_Feature(handle)
	op.ParentSequence = ptrFromHandle_Ptr_genbank_Genbank(val)
}

//export genbank_Feature_GetSequence
func genbank_Feature_GetSequence(_handle CGoHandle) *C.char {
	_saved_thread := C.PyEval_SaveThread()
	vifc, __err := gopyh.VarFromHandleTry((gopyh.CGoHandle)(_handle), "*genbank.Feature")
	if __err != nil {
		return C.CString("")
	}
	cret, __err := gopyh.Embed(vifc, reflect.TypeOf(genbank.Feature{})).(*genbank.Feature).GetSequence()

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return C.CString("")
	}
	return C.CString(cret)
}

// --- wrapping struct: genbank.Genbank ---
//
//export genbank_Genbank_CTor
func genbank_Genbank_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_genbank_Genbank(&genbank.Genbank{}))
}

//export genbank_Genbank_Meta_Get
func genbank_Genbank_Meta_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_genbank_Genbank(handle)
	return handleFromPtr_genbank_Meta(&op.Meta)
}

//export genbank_Genbank_Meta_Set
func genbank_Genbank_Meta_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_genbank_Genbank(handle)
	op.Meta = *ptrFromHandle_genbank_Meta(val)
}

//export genbank_Genbank_Features_Get
func genbank_Genbank_Features_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_genbank_Genbank(handle)
	return handleFromPtr_Slice_genbank_Feature(&op.Features)
}

//export genbank_Genbank_Features_Set
func genbank_Genbank_Features_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_genbank_Genbank(handle)
	op.Features = deptrFromHandle_Slice_genbank_Feature(val)
}

//export genbank_Genbank_Sequence_Get
func genbank_Genbank_Sequence_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Genbank(handle)
	return C.CString(op.Sequence)
}

//export genbank_Genbank_Sequence_Set
func genbank_Genbank_Sequence_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Genbank(handle)
	op.Sequence = C.GoString(val)
}

//export genbank_Genbank_AddFeature
func genbank_Genbank_AddFeature(_handle CGoHandle, feature CGoHandle) *C.char {
	_saved_thread := C.PyEval_SaveThread()
	vifc, __err := gopyh.VarFromHandleTry((gopyh.CGoHandle)(_handle), "*genbank.Genbank")
	if __err != nil {
		return errorGoToPy(nil)
	}
	__err = gopyh.Embed(vifc, reflect.TypeOf(genbank.Genbank{})).(*genbank.Genbank).AddFeature(ptrFromHandle_Ptr_genbank_Feature(feature))

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		return estr
	}
	return C.CString("")
}

// --- wrapping struct: genbank.Location ---
//
//export genbank_Location_CTor
func genbank_Location_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_genbank_Location(&genbank.Location{}))
}

//export genbank_Location_Start_Get
func genbank_Location_Start_Get(handle CGoHandle) C.longlong {
	op := ptrFromHandle_genbank_Location(handle)
	return C.longlong(op.Start)
}

//export genbank_Location_Start_Set
func genbank_Location_Start_Set(handle CGoHandle, val C.longlong) {
	op := ptrFromHandle_genbank_Location(handle)
	op.Start = int(val)
}

//export genbank_Location_End_Get
func genbank_Location_End_Get(handle CGoHandle) C.longlong {
	op := ptrFromHandle_genbank_Location(handle)
	return C.longlong(op.End)
}

//export genbank_Location_End_Set
func genbank_Location_End_Set(handle CGoHandle, val C.longlong) {
	op := ptrFromHandle_genbank_Location(handle)
	op.End = int(val)
}

//export genbank_Location_Complement_Get
func genbank_Location_Complement_Get(handle CGoHandle) C.char {
	op := ptrFromHandle_genbank_Location(handle)
	return boolGoToPy(op.Complement)
}

//export genbank_Location_Complement_Set
func genbank_Location_Complement_Set(handle CGoHandle, val C.char) {
	op := ptrFromHandle_genbank_Location(handle)
	op.Complement = boolPyToGo(val)
}

//export genbank_Location_Join_Get
func genbank_Location_Join_Get(handle CGoHandle) C.char {
	op := ptrFromHandle_genbank_Location(handle)
	return boolGoToPy(op.Join)
}

//export genbank_Location_Join_Set
func genbank_Location_Join_Set(handle CGoHandle, val C.char) {
	op := ptrFromHandle_genbank_Location(handle)
	op.Join = boolPyToGo(val)
}

//export genbank_Location_FivePrimePartial_Get
func genbank_Location_FivePrimePartial_Get(handle CGoHandle) C.char {
	op := ptrFromHandle_genbank_Location(handle)
	return boolGoToPy(op.FivePrimePartial)
}

//export genbank_Location_FivePrimePartial_Set
func genbank_Location_FivePrimePartial_Set(handle CGoHandle, val C.char) {
	op := ptrFromHandle_genbank_Location(handle)
	op.FivePrimePartial = boolPyToGo(val)
}

//export genbank_Location_ThreePrimePartial_Get
func genbank_Location_ThreePrimePartial_Get(handle CGoHandle) C.char {
	op := ptrFromHandle_genbank_Location(handle)
	return boolGoToPy(op.ThreePrimePartial)
}

//export genbank_Location_ThreePrimePartial_Set
func genbank_Location_ThreePrimePartial_Set(handle CGoHandle, val C.char) {
	op := ptrFromHandle_genbank_Location(handle)
	op.ThreePrimePartial = boolPyToGo(val)
}

//export genbank_Location_GbkLocationString_Get
func genbank_Location_GbkLocationString_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_genbank_Location(handle)
	return C.CString(op.GbkLocationString)
}

//export genbank_Location_GbkLocationString_Set
func genbank_Location_GbkLocationString_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_genbank_Location(handle)
	op.GbkLocationString = C.GoString(val)
}

//export genbank_Location_SubLocations_Get
func genbank_Location_SubLocations_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_genbank_Location(handle)
	return handleFromPtr_Slice_genbank_Location(&op.SubLocations)
}

//export genbank_Location_SubLocations_Set
func genbank_Location_SubLocations_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_genbank_Location(handle)
	op.SubLocations = deptrFromHandle_Slice_genbank_Location(val)
}

// ---- Slices ---

// ---- Maps ---

// ---- Constructors ---

//export genbank_Parse
func genbank_Parse(r CGoHandle) CGoHandle {
	_saved_thread := C.PyEval_SaveThread()
	cret, __err := genbank.Parse(ptrFromHandle_io_Reader(r))

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return handleFromPtr_genbank_Genbank(nil)
	}
	return handleFromPtr_genbank_Genbank(&cret)
}

//export genbank_Read
func genbank_Read(path *C.char) CGoHandle {
	_saved_thread := C.PyEval_SaveThread()
	cret, __err := genbank.Read(C.GoString(path))

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return handleFromPtr_genbank_Genbank(nil)
	}
	return handleFromPtr_genbank_Genbank(&cret)
}

// ---- Functions ---

//export genbank_ReadMultiNth
func genbank_ReadMultiNth(path *C.char, count C.longlong) CGoHandle {
	_saved_thread := C.PyEval_SaveThread()
	cret, __err := genbank.ReadMultiNth(C.GoString(path), int(count))

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return handleFromPtr_Slice_genbank_Genbank(nil)
	}
	return handleFromPtr_Slice_genbank_Genbank(&cret)
}

//export genbank_Build
func genbank_Build(gbk CGoHandle) CGoHandle {
	_saved_thread := C.PyEval_SaveThread()
	cret, __err := genbank.Build(*ptrFromHandle_genbank_Genbank(gbk))

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return handleFromPtr_Slice_byte(nil)
	}
	return handleFromPtr_Slice_byte(&cret)
}

//export genbank_BuildMulti
func genbank_BuildMulti(sequences CGoHandle) CGoHandle {
	_saved_thread := C.PyEval_SaveThread()
	cret, __err := genbank.BuildMulti(deptrFromHandle_Slice_genbank_Genbank(sequences))

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return handleFromPtr_Slice_byte(nil)
	}
	return handleFromPtr_Slice_byte(&cret)
}

//export genbank_ParseMulti
func genbank_ParseMulti(r CGoHandle) CGoHandle {
	_saved_thread := C.PyEval_SaveThread()
	cret, __err := genbank.ParseMulti(ptrFromHandle_io_Reader(r))

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return handleFromPtr_Slice_genbank_Genbank(nil)
	}
	return handleFromPtr_Slice_genbank_Genbank(&cret)
}

//export genbank_ParseMultiNth
func genbank_ParseMultiNth(r CGoHandle, count C.longlong) CGoHandle {
	_saved_thread := C.PyEval_SaveThread()
	cret, __err := genbank.ParseMultiNth(ptrFromHandle_io_Reader(r), int(count))

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return handleFromPtr_Slice_genbank_Genbank(nil)
	}
	return handleFromPtr_Slice_genbank_Genbank(&cret)
}

//export genbank_ReadMulti
func genbank_ReadMulti(path *C.char) CGoHandle {
	_saved_thread := C.PyEval_SaveThread()
	cret, __err := genbank.ReadMulti(C.GoString(path))

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return handleFromPtr_Slice_genbank_Genbank(nil)
	}
	return handleFromPtr_Slice_genbank_Genbank(&cret)
}

//export genbank_Write
func genbank_Write(sequences CGoHandle, path *C.char) *C.char {
	_saved_thread := C.PyEval_SaveThread()
	var __err error
	__err = genbank.Write(*ptrFromHandle_genbank_Genbank(sequences), C.GoString(path))

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		return estr
	}
	return C.CString("")
}

//export genbank_WriteMulti
func genbank_WriteMulti(sequences CGoHandle, path *C.char) *C.char {
	_saved_thread := C.PyEval_SaveThread()
	var __err error
	__err = genbank.WriteMulti(deptrFromHandle_Slice_genbank_Genbank(sequences), C.GoString(path))

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		return estr
	}
	return C.CString("")
}

//export genbank_BuildFeatureString
func genbank_BuildFeatureString(feature CGoHandle) *C.char {
	_saved_thread := C.PyEval_SaveThread()
	defer C.PyEval_RestoreThread(_saved_thread)
	return C.CString(genbank.BuildFeatureString(*ptrFromHandle_genbank_Feature(feature)))

}

//export genbank_BuildLocationString
func genbank_BuildLocationString(location CGoHandle) *C.char {
	_saved_thread := C.PyEval_SaveThread()
	defer C.PyEval_RestoreThread(_saved_thread)
	return C.CString(genbank.BuildLocationString(*ptrFromHandle_genbank_Location(location)))

}
