/*
cgo stubs for package codon.
File is generated by gopy. Do not edit.
gopy build -output=poly/synthesis/codon -vm=python3 github.com/bebop/poly/synthesis/codon
*/

package main

/*

#cgo CFLAGS: "-I/opt/homebrew/opt/python@3.13/Frameworks/Python.framework/Versions/3.13/include/python3.13" -Wno-error -Wno-implicit-function-declaration -Wno-int-conversion
#cgo LDFLAGS: "-L/opt/homebrew/opt/python@3.13/Frameworks/Python.framework/Versions/3.13/lib" "-lpython3.13" -ldl  -framework CoreFoundation

// #define Py_LIMITED_API // need full API for PyRun*
#include <Python.h>
typedef uint8_t bool;
// static inline is trick for avoiding need for extra .c file
// the following are used for build value -- switch on reflect.Kind
// or the types equivalent
static inline PyObject* gopy_build_bool(uint8_t val) {
	return Py_BuildValue("b", val);
}
static inline PyObject* gopy_build_int64(int64_t val) {
	return Py_BuildValue("k", val);
}
static inline PyObject* gopy_build_uint64(uint64_t val) {
	return Py_BuildValue("K", val);
}
static inline PyObject* gopy_build_float64(double val) {
	return Py_BuildValue("d", val);
}
static inline PyObject* gopy_build_string(const char* val) {
	return Py_BuildValue("s", val);
}
static inline void gopy_decref(PyObject* obj) { // macro
	Py_XDECREF(obj);
}
static inline void gopy_incref(PyObject* obj) { // macro
	Py_XINCREF(obj);
}
static inline int gopy_method_check(PyObject* obj) { // macro
	return PyMethod_Check(obj);
}
static inline void gopy_err_handle() {
	if(PyErr_Occurred() != NULL) {
		PyErr_Print();
	}
}

*/
import "C"
import (
	"errors"
	"reflect"
	"unsafe"

	"github.com/go-python/gopy/gopyh" // handler

	"github.com/bebop/poly/io/genbank"
	"github.com/bebop/poly/synthesis/codon"
	"github.com/mroth/weightedrand"
)

// main doesn't do anything in lib / pkg mode, but is essential for exe mode
func main() {

}

// initialization functions -- can be called from python after library is loaded
// GoPyInitRunFile runs a separate python file -- call in GoPyInit if it
// steals the main thread e.g., for GUI event loop, as in GoGi startup.

//export GoPyInit
func GoPyInit() {

}

// type for the handle -- int64 for speed (can switch to string)
type GoHandle int64
type CGoHandle C.longlong

// DecRef decrements the reference count for the specified handle
// and deletes it it goes to zero.
//
//export DecRef
func DecRef(handle CGoHandle) {
	gopyh.DecRef(gopyh.CGoHandle(handle))
}

// IncRef increments the reference count for the specified handle.
//
//export IncRef
func IncRef(handle CGoHandle) {
	gopyh.IncRef(gopyh.CGoHandle(handle))
}

// NumHandles returns the number of handles currently in use.
//
//export NumHandles
func NumHandles() int {
	return gopyh.NumHandles()
}

// boolGoToPy converts a Go bool to python-compatible C.char
func boolGoToPy(b bool) C.char {
	if b {
		return 1
	}
	return 0
}

// boolPyToGo converts a python-compatible C.Char to Go bool
func boolPyToGo(b C.char) bool {
	if b != 0 {
		return true
	}
	return false
}

func complex64GoToPy(c complex64) *C.PyObject {
	return C.PyComplex_FromDoubles(C.double(real(c)), C.double(imag(c)))
}

func complex64PyToGo(o *C.PyObject) complex64 {
	v := C.PyComplex_AsCComplex(o)
	return complex(float32(v.real), float32(v.imag))
}

func complex128GoToPy(c complex128) *C.PyObject {
	return C.PyComplex_FromDoubles(C.double(real(c)), C.double(imag(c)))
}

func complex128PyToGo(o *C.PyObject) complex128 {
	v := C.PyComplex_AsCComplex(o)
	return complex(float64(v.real), float64(v.imag))
}

// errorGoToPy converts a Go error to python-compatible C.CString
func errorGoToPy(e error) *C.char {
	if e != nil {
		return C.CString(e.Error())
	}
	return C.CString("")
}

// --- generated code for package: codon below: ---

// ---- External Types Outside of Targeted Packages ---

// Converters for pointer handles for type: *genbank.Feature
func ptrFromHandle_Ptr_genbank_Feature(h CGoHandle) *genbank.Feature {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "*genbank.Feature")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Feature{})).(*genbank.Feature)
}
func handleFromPtr_Ptr_genbank_Feature(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("*genbank.Feature", p))
}

// Converters for pointer handles for type: *genbank.Genbank
func ptrFromHandle_Ptr_genbank_Genbank(h CGoHandle) *genbank.Genbank {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "*genbank.Genbank")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Genbank{})).(*genbank.Genbank)
}
func handleFromPtr_Ptr_genbank_Genbank(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("*genbank.Genbank", p))
}

// Converters for non-pointer handles for type: genbank.BaseCount
func ptrFromHandle_genbank_BaseCount(h CGoHandle) *genbank.BaseCount {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "genbank.BaseCount")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.BaseCount{})).(*genbank.BaseCount)
}
func handleFromPtr_genbank_BaseCount(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("genbank.BaseCount", p))
}

// Converters for non-pointer handles for type: genbank.Feature
func ptrFromHandle_genbank_Feature(h CGoHandle) *genbank.Feature {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "genbank.Feature")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Feature{})).(*genbank.Feature)
}
func handleFromPtr_genbank_Feature(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("genbank.Feature", p))
}

// Converters for non-pointer handles for type: genbank.Genbank
func ptrFromHandle_genbank_Genbank(h CGoHandle) *genbank.Genbank {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "genbank.Genbank")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Genbank{})).(*genbank.Genbank)
}
func handleFromPtr_genbank_Genbank(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("genbank.Genbank", p))
}

// Converters for non-pointer handles for type: genbank.Location
func ptrFromHandle_genbank_Location(h CGoHandle) *genbank.Location {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "genbank.Location")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Location{})).(*genbank.Location)
}
func handleFromPtr_genbank_Location(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("genbank.Location", p))
}

// Converters for non-pointer handles for type: genbank.Locus
func ptrFromHandle_genbank_Locus(h CGoHandle) *genbank.Locus {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "genbank.Locus")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Locus{})).(*genbank.Locus)
}
func handleFromPtr_genbank_Locus(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("genbank.Locus", p))
}

// Converters for non-pointer handles for type: genbank.Meta
func ptrFromHandle_genbank_Meta(h CGoHandle) *genbank.Meta {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "genbank.Meta")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Meta{})).(*genbank.Meta)
}
func handleFromPtr_genbank_Meta(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("genbank.Meta", p))
}

// Converters for non-pointer handles for type: genbank.Reference
func ptrFromHandle_genbank_Reference(h CGoHandle) *genbank.Reference {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "genbank.Reference")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(genbank.Reference{})).(*genbank.Reference)
}
func handleFromPtr_genbank_Reference(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("genbank.Reference", p))
}

// Converters for non-pointer handles for type: weightedrand.Chooser
func ptrFromHandle_weightedrand_Chooser(h CGoHandle) *weightedrand.Chooser {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "weightedrand.Chooser")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(weightedrand.Chooser{})).(*weightedrand.Chooser)
}
func handleFromPtr_weightedrand_Chooser(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("weightedrand.Chooser", p))
}

// ---- Package: go ---

// ---- Types ---

// Converters for implicit pointer handles for type: []bool
func ptrFromHandle_Slice_bool(h CGoHandle) *[]bool {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]bool")
	if p == nil {
		return nil
	}
	return p.(*[]bool)
}
func deptrFromHandle_Slice_bool(h CGoHandle) []bool {
	p := ptrFromHandle_Slice_bool(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_bool(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]bool", p))
}

// --- wrapping slice: []bool ---
//
//export Slice_bool_CTor
func Slice_bool_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_bool(&[]bool{}))
}

//export Slice_bool_len
func Slice_bool_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_bool(handle))
}

//export Slice_bool_elem
func Slice_bool_elem(handle CGoHandle, _idx int) C.char {
	s := deptrFromHandle_Slice_bool(handle)
	return boolGoToPy(s[_idx])
}

//export Slice_bool_subslice
func Slice_bool_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_bool(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_bool(&ss))
}

//export Slice_bool_set
func Slice_bool_set(handle CGoHandle, _idx int, _vl C.char) {
	s := deptrFromHandle_Slice_bool(handle)
	s[_idx] = boolPyToGo(_vl)
}

//export Slice_bool_append
func Slice_bool_append(handle CGoHandle, _vl C.char) {
	s := ptrFromHandle_Slice_bool(handle)
	*s = append(*s, boolPyToGo(_vl))
}

// Converters for implicit pointer handles for type: []byte
func ptrFromHandle_Slice_byte(h CGoHandle) *[]byte {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]byte")
	if p == nil {
		return nil
	}
	return p.(*[]byte)
}
func deptrFromHandle_Slice_byte(h CGoHandle) []byte {
	p := ptrFromHandle_Slice_byte(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_byte(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]byte", p))
}

// --- wrapping slice: []byte ---
//
//export Slice_byte_CTor
func Slice_byte_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_byte(&[]byte{}))
}

//export Slice_byte_len
func Slice_byte_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_byte(handle))
}

//export Slice_byte_elem
func Slice_byte_elem(handle CGoHandle, _idx int) C.char {
	s := deptrFromHandle_Slice_byte(handle)
	return C.char(s[_idx])
}

//export Slice_byte_subslice
func Slice_byte_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_byte(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_byte(&ss))
}

//export Slice_byte_set
func Slice_byte_set(handle CGoHandle, _idx int, _vl C.char) {
	s := deptrFromHandle_Slice_byte(handle)
	s[_idx] = byte(_vl)
}

//export Slice_byte_append
func Slice_byte_append(handle CGoHandle, _vl C.char) {
	s := ptrFromHandle_Slice_byte(handle)
	*s = append(*s, byte(_vl))
}

//export Slice_byte_from_bytes
func Slice_byte_from_bytes(o *C.PyObject) CGoHandle {
	size := C.PyBytes_Size(o)
	ptr := unsafe.Pointer(C.PyBytes_AsString(o))
	data := make([]byte, size)
	tmp := unsafe.Slice((*byte)(ptr), size)
	copy(data, tmp)
	return handleFromPtr_Slice_byte(&data)
}

//export Slice_byte_to_bytes
func Slice_byte_to_bytes(handle CGoHandle) *C.PyObject {
	s := deptrFromHandle_Slice_byte(handle)
	ptr := unsafe.Pointer(&s[0])
	size := len(s)
	return C.PyBytes_FromStringAndSize((*C.char)(ptr), C.long(size))
}

// Converters for implicit pointer handles for type: []error
func ptrFromHandle_Slice_error(h CGoHandle) *[]error {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]error")
	if p == nil {
		return nil
	}
	return p.(*[]error)
}
func deptrFromHandle_Slice_error(h CGoHandle) []error {
	p := ptrFromHandle_Slice_error(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_error(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]error", p))
}

// --- wrapping slice: []error ---
//
//export Slice_error_CTor
func Slice_error_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_error(&[]error{}))
}

//export Slice_error_len
func Slice_error_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_error(handle))
}

//export Slice_error_elem
func Slice_error_elem(handle CGoHandle, _idx int) *C.char {
	s := deptrFromHandle_Slice_error(handle)
	return errorGoToPy(s[_idx])
}

//export Slice_error_subslice
func Slice_error_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_error(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_error(&ss))
}

//export Slice_error_set
func Slice_error_set(handle CGoHandle, _idx int, _vl *C.char) {
	s := deptrFromHandle_Slice_error(handle)
	s[_idx] = errors.New(C.GoString(_vl))
}

//export Slice_error_append
func Slice_error_append(handle CGoHandle, _vl *C.char) {
	s := ptrFromHandle_Slice_error(handle)
	*s = append(*s, errors.New(C.GoString(_vl)))
}

// Converters for implicit pointer handles for type: []float32
func ptrFromHandle_Slice_float32(h CGoHandle) *[]float32 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]float32")
	if p == nil {
		return nil
	}
	return p.(*[]float32)
}
func deptrFromHandle_Slice_float32(h CGoHandle) []float32 {
	p := ptrFromHandle_Slice_float32(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_float32(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]float32", p))
}

// --- wrapping slice: []float32 ---
//
//export Slice_float32_CTor
func Slice_float32_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_float32(&[]float32{}))
}

//export Slice_float32_len
func Slice_float32_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_float32(handle))
}

//export Slice_float32_elem
func Slice_float32_elem(handle CGoHandle, _idx int) C.float {
	s := deptrFromHandle_Slice_float32(handle)
	return C.float(s[_idx])
}

//export Slice_float32_subslice
func Slice_float32_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_float32(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_float32(&ss))
}

//export Slice_float32_set
func Slice_float32_set(handle CGoHandle, _idx int, _vl C.float) {
	s := deptrFromHandle_Slice_float32(handle)
	s[_idx] = float32(_vl)
}

//export Slice_float32_append
func Slice_float32_append(handle CGoHandle, _vl C.float) {
	s := ptrFromHandle_Slice_float32(handle)
	*s = append(*s, float32(_vl))
}

// Converters for implicit pointer handles for type: []float64
func ptrFromHandle_Slice_float64(h CGoHandle) *[]float64 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]float64")
	if p == nil {
		return nil
	}
	return p.(*[]float64)
}
func deptrFromHandle_Slice_float64(h CGoHandle) []float64 {
	p := ptrFromHandle_Slice_float64(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_float64(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]float64", p))
}

// --- wrapping slice: []float64 ---
//
//export Slice_float64_CTor
func Slice_float64_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_float64(&[]float64{}))
}

//export Slice_float64_len
func Slice_float64_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_float64(handle))
}

//export Slice_float64_elem
func Slice_float64_elem(handle CGoHandle, _idx int) C.double {
	s := deptrFromHandle_Slice_float64(handle)
	return C.double(s[_idx])
}

//export Slice_float64_subslice
func Slice_float64_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_float64(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_float64(&ss))
}

//export Slice_float64_set
func Slice_float64_set(handle CGoHandle, _idx int, _vl C.double) {
	s := deptrFromHandle_Slice_float64(handle)
	s[_idx] = float64(_vl)
}

//export Slice_float64_append
func Slice_float64_append(handle CGoHandle, _vl C.double) {
	s := ptrFromHandle_Slice_float64(handle)
	*s = append(*s, float64(_vl))
}

// Converters for implicit pointer handles for type: []int
func ptrFromHandle_Slice_int(h CGoHandle) *[]int {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]int")
	if p == nil {
		return nil
	}
	return p.(*[]int)
}
func deptrFromHandle_Slice_int(h CGoHandle) []int {
	p := ptrFromHandle_Slice_int(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_int(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]int", p))
}

// --- wrapping slice: []int ---
//
//export Slice_int_CTor
func Slice_int_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_int(&[]int{}))
}

//export Slice_int_len
func Slice_int_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_int(handle))
}

//export Slice_int_elem
func Slice_int_elem(handle CGoHandle, _idx int) C.longlong {
	s := deptrFromHandle_Slice_int(handle)
	return C.longlong(s[_idx])
}

//export Slice_int_subslice
func Slice_int_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_int(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_int(&ss))
}

//export Slice_int_set
func Slice_int_set(handle CGoHandle, _idx int, _vl C.longlong) {
	s := deptrFromHandle_Slice_int(handle)
	s[_idx] = int(_vl)
}

//export Slice_int_append
func Slice_int_append(handle CGoHandle, _vl C.longlong) {
	s := ptrFromHandle_Slice_int(handle)
	*s = append(*s, int(_vl))
}

// Converters for implicit pointer handles for type: []int16
func ptrFromHandle_Slice_int16(h CGoHandle) *[]int16 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]int16")
	if p == nil {
		return nil
	}
	return p.(*[]int16)
}
func deptrFromHandle_Slice_int16(h CGoHandle) []int16 {
	p := ptrFromHandle_Slice_int16(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_int16(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]int16", p))
}

// --- wrapping slice: []int16 ---
//
//export Slice_int16_CTor
func Slice_int16_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_int16(&[]int16{}))
}

//export Slice_int16_len
func Slice_int16_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_int16(handle))
}

//export Slice_int16_elem
func Slice_int16_elem(handle CGoHandle, _idx int) C.short {
	s := deptrFromHandle_Slice_int16(handle)
	return C.short(s[_idx])
}

//export Slice_int16_subslice
func Slice_int16_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_int16(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_int16(&ss))
}

//export Slice_int16_set
func Slice_int16_set(handle CGoHandle, _idx int, _vl C.short) {
	s := deptrFromHandle_Slice_int16(handle)
	s[_idx] = int16(_vl)
}

//export Slice_int16_append
func Slice_int16_append(handle CGoHandle, _vl C.short) {
	s := ptrFromHandle_Slice_int16(handle)
	*s = append(*s, int16(_vl))
}

// Converters for implicit pointer handles for type: []int32
func ptrFromHandle_Slice_int32(h CGoHandle) *[]int32 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]int32")
	if p == nil {
		return nil
	}
	return p.(*[]int32)
}
func deptrFromHandle_Slice_int32(h CGoHandle) []int32 {
	p := ptrFromHandle_Slice_int32(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_int32(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]int32", p))
}

// --- wrapping slice: []int32 ---
//
//export Slice_int32_CTor
func Slice_int32_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_int32(&[]int32{}))
}

//export Slice_int32_len
func Slice_int32_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_int32(handle))
}

//export Slice_int32_elem
func Slice_int32_elem(handle CGoHandle, _idx int) C.long {
	s := deptrFromHandle_Slice_int32(handle)
	return C.long(s[_idx])
}

//export Slice_int32_subslice
func Slice_int32_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_int32(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_int32(&ss))
}

//export Slice_int32_set
func Slice_int32_set(handle CGoHandle, _idx int, _vl C.long) {
	s := deptrFromHandle_Slice_int32(handle)
	s[_idx] = int32(_vl)
}

//export Slice_int32_append
func Slice_int32_append(handle CGoHandle, _vl C.long) {
	s := ptrFromHandle_Slice_int32(handle)
	*s = append(*s, int32(_vl))
}

// Converters for implicit pointer handles for type: []int64
func ptrFromHandle_Slice_int64(h CGoHandle) *[]int64 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]int64")
	if p == nil {
		return nil
	}
	return p.(*[]int64)
}
func deptrFromHandle_Slice_int64(h CGoHandle) []int64 {
	p := ptrFromHandle_Slice_int64(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_int64(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]int64", p))
}

// --- wrapping slice: []int64 ---
//
//export Slice_int64_CTor
func Slice_int64_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_int64(&[]int64{}))
}

//export Slice_int64_len
func Slice_int64_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_int64(handle))
}

//export Slice_int64_elem
func Slice_int64_elem(handle CGoHandle, _idx int) C.longlong {
	s := deptrFromHandle_Slice_int64(handle)
	return C.longlong(s[_idx])
}

//export Slice_int64_subslice
func Slice_int64_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_int64(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_int64(&ss))
}

//export Slice_int64_set
func Slice_int64_set(handle CGoHandle, _idx int, _vl C.longlong) {
	s := deptrFromHandle_Slice_int64(handle)
	s[_idx] = int64(_vl)
}

//export Slice_int64_append
func Slice_int64_append(handle CGoHandle, _vl C.longlong) {
	s := ptrFromHandle_Slice_int64(handle)
	*s = append(*s, int64(_vl))
}

// Converters for implicit pointer handles for type: []int8
func ptrFromHandle_Slice_int8(h CGoHandle) *[]int8 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]int8")
	if p == nil {
		return nil
	}
	return p.(*[]int8)
}
func deptrFromHandle_Slice_int8(h CGoHandle) []int8 {
	p := ptrFromHandle_Slice_int8(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_int8(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]int8", p))
}

// --- wrapping slice: []int8 ---
//
//export Slice_int8_CTor
func Slice_int8_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_int8(&[]int8{}))
}

//export Slice_int8_len
func Slice_int8_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_int8(handle))
}

//export Slice_int8_elem
func Slice_int8_elem(handle CGoHandle, _idx int) C.char {
	s := deptrFromHandle_Slice_int8(handle)
	return C.char(s[_idx])
}

//export Slice_int8_subslice
func Slice_int8_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_int8(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_int8(&ss))
}

//export Slice_int8_set
func Slice_int8_set(handle CGoHandle, _idx int, _vl C.char) {
	s := deptrFromHandle_Slice_int8(handle)
	s[_idx] = int8(_vl)
}

//export Slice_int8_append
func Slice_int8_append(handle CGoHandle, _vl C.char) {
	s := ptrFromHandle_Slice_int8(handle)
	*s = append(*s, int8(_vl))
}

// Converters for implicit pointer handles for type: []rune
func ptrFromHandle_Slice_rune(h CGoHandle) *[]rune {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]rune")
	if p == nil {
		return nil
	}
	return p.(*[]rune)
}
func deptrFromHandle_Slice_rune(h CGoHandle) []rune {
	p := ptrFromHandle_Slice_rune(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_rune(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]rune", p))
}

// --- wrapping slice: []rune ---
//
//export Slice_rune_CTor
func Slice_rune_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_rune(&[]rune{}))
}

//export Slice_rune_len
func Slice_rune_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_rune(handle))
}

//export Slice_rune_elem
func Slice_rune_elem(handle CGoHandle, _idx int) C.long {
	s := deptrFromHandle_Slice_rune(handle)
	return C.long(s[_idx])
}

//export Slice_rune_subslice
func Slice_rune_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_rune(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_rune(&ss))
}

//export Slice_rune_set
func Slice_rune_set(handle CGoHandle, _idx int, _vl C.long) {
	s := deptrFromHandle_Slice_rune(handle)
	s[_idx] = rune(_vl)
}

//export Slice_rune_append
func Slice_rune_append(handle CGoHandle, _vl C.long) {
	s := ptrFromHandle_Slice_rune(handle)
	*s = append(*s, rune(_vl))
}

// Converters for implicit pointer handles for type: []string
func ptrFromHandle_Slice_string(h CGoHandle) *[]string {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]string")
	if p == nil {
		return nil
	}
	return p.(*[]string)
}
func deptrFromHandle_Slice_string(h CGoHandle) []string {
	p := ptrFromHandle_Slice_string(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_string(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]string", p))
}

// --- wrapping slice: []string ---
//
//export Slice_string_CTor
func Slice_string_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_string(&[]string{}))
}

//export Slice_string_len
func Slice_string_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_string(handle))
}

//export Slice_string_elem
func Slice_string_elem(handle CGoHandle, _idx int) *C.char {
	s := deptrFromHandle_Slice_string(handle)
	return C.CString(s[_idx])
}

//export Slice_string_subslice
func Slice_string_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_string(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_string(&ss))
}

//export Slice_string_set
func Slice_string_set(handle CGoHandle, _idx int, _vl *C.char) {
	s := deptrFromHandle_Slice_string(handle)
	s[_idx] = C.GoString(_vl)
}

//export Slice_string_append
func Slice_string_append(handle CGoHandle, _vl *C.char) {
	s := ptrFromHandle_Slice_string(handle)
	*s = append(*s, C.GoString(_vl))
}

// Converters for implicit pointer handles for type: []uint
func ptrFromHandle_Slice_uint(h CGoHandle) *[]uint {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]uint")
	if p == nil {
		return nil
	}
	return p.(*[]uint)
}
func deptrFromHandle_Slice_uint(h CGoHandle) []uint {
	p := ptrFromHandle_Slice_uint(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_uint(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]uint", p))
}

// --- wrapping slice: []uint ---
//
//export Slice_uint_CTor
func Slice_uint_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_uint(&[]uint{}))
}

//export Slice_uint_len
func Slice_uint_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_uint(handle))
}

//export Slice_uint_elem
func Slice_uint_elem(handle CGoHandle, _idx int) C.ulonglong {
	s := deptrFromHandle_Slice_uint(handle)
	return C.ulonglong(s[_idx])
}

//export Slice_uint_subslice
func Slice_uint_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_uint(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_uint(&ss))
}

//export Slice_uint_set
func Slice_uint_set(handle CGoHandle, _idx int, _vl C.ulonglong) {
	s := deptrFromHandle_Slice_uint(handle)
	s[_idx] = uint(_vl)
}

//export Slice_uint_append
func Slice_uint_append(handle CGoHandle, _vl C.ulonglong) {
	s := ptrFromHandle_Slice_uint(handle)
	*s = append(*s, uint(_vl))
}

// Converters for implicit pointer handles for type: []uint16
func ptrFromHandle_Slice_uint16(h CGoHandle) *[]uint16 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]uint16")
	if p == nil {
		return nil
	}
	return p.(*[]uint16)
}
func deptrFromHandle_Slice_uint16(h CGoHandle) []uint16 {
	p := ptrFromHandle_Slice_uint16(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_uint16(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]uint16", p))
}

// --- wrapping slice: []uint16 ---
//
//export Slice_uint16_CTor
func Slice_uint16_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_uint16(&[]uint16{}))
}

//export Slice_uint16_len
func Slice_uint16_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_uint16(handle))
}

//export Slice_uint16_elem
func Slice_uint16_elem(handle CGoHandle, _idx int) C.ushort {
	s := deptrFromHandle_Slice_uint16(handle)
	return C.ushort(s[_idx])
}

//export Slice_uint16_subslice
func Slice_uint16_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_uint16(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_uint16(&ss))
}

//export Slice_uint16_set
func Slice_uint16_set(handle CGoHandle, _idx int, _vl C.ushort) {
	s := deptrFromHandle_Slice_uint16(handle)
	s[_idx] = uint16(_vl)
}

//export Slice_uint16_append
func Slice_uint16_append(handle CGoHandle, _vl C.ushort) {
	s := ptrFromHandle_Slice_uint16(handle)
	*s = append(*s, uint16(_vl))
}

// Converters for implicit pointer handles for type: []uint32
func ptrFromHandle_Slice_uint32(h CGoHandle) *[]uint32 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]uint32")
	if p == nil {
		return nil
	}
	return p.(*[]uint32)
}
func deptrFromHandle_Slice_uint32(h CGoHandle) []uint32 {
	p := ptrFromHandle_Slice_uint32(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_uint32(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]uint32", p))
}

// --- wrapping slice: []uint32 ---
//
//export Slice_uint32_CTor
func Slice_uint32_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_uint32(&[]uint32{}))
}

//export Slice_uint32_len
func Slice_uint32_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_uint32(handle))
}

//export Slice_uint32_elem
func Slice_uint32_elem(handle CGoHandle, _idx int) C.ulong {
	s := deptrFromHandle_Slice_uint32(handle)
	return C.ulong(s[_idx])
}

//export Slice_uint32_subslice
func Slice_uint32_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_uint32(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_uint32(&ss))
}

//export Slice_uint32_set
func Slice_uint32_set(handle CGoHandle, _idx int, _vl C.ulong) {
	s := deptrFromHandle_Slice_uint32(handle)
	s[_idx] = uint32(_vl)
}

//export Slice_uint32_append
func Slice_uint32_append(handle CGoHandle, _vl C.ulong) {
	s := ptrFromHandle_Slice_uint32(handle)
	*s = append(*s, uint32(_vl))
}

// Converters for implicit pointer handles for type: []uint64
func ptrFromHandle_Slice_uint64(h CGoHandle) *[]uint64 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]uint64")
	if p == nil {
		return nil
	}
	return p.(*[]uint64)
}
func deptrFromHandle_Slice_uint64(h CGoHandle) []uint64 {
	p := ptrFromHandle_Slice_uint64(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_uint64(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]uint64", p))
}

// --- wrapping slice: []uint64 ---
//
//export Slice_uint64_CTor
func Slice_uint64_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_uint64(&[]uint64{}))
}

//export Slice_uint64_len
func Slice_uint64_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_uint64(handle))
}

//export Slice_uint64_elem
func Slice_uint64_elem(handle CGoHandle, _idx int) C.ulonglong {
	s := deptrFromHandle_Slice_uint64(handle)
	return C.ulonglong(s[_idx])
}

//export Slice_uint64_subslice
func Slice_uint64_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_uint64(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_uint64(&ss))
}

//export Slice_uint64_set
func Slice_uint64_set(handle CGoHandle, _idx int, _vl C.ulonglong) {
	s := deptrFromHandle_Slice_uint64(handle)
	s[_idx] = uint64(_vl)
}

//export Slice_uint64_append
func Slice_uint64_append(handle CGoHandle, _vl C.ulonglong) {
	s := ptrFromHandle_Slice_uint64(handle)
	*s = append(*s, uint64(_vl))
}

// Converters for implicit pointer handles for type: []uint8
func ptrFromHandle_Slice_uint8(h CGoHandle) *[]uint8 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]uint8")
	if p == nil {
		return nil
	}
	return p.(*[]uint8)
}
func deptrFromHandle_Slice_uint8(h CGoHandle) []uint8 {
	p := ptrFromHandle_Slice_uint8(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_uint8(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]uint8", p))
}

// --- wrapping slice: []uint8 ---
//
//export Slice_uint8_CTor
func Slice_uint8_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_uint8(&[]uint8{}))
}

//export Slice_uint8_len
func Slice_uint8_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_uint8(handle))
}

//export Slice_uint8_elem
func Slice_uint8_elem(handle CGoHandle, _idx int) C.uchar {
	s := deptrFromHandle_Slice_uint8(handle)
	return C.uchar(s[_idx])
}

//export Slice_uint8_subslice
func Slice_uint8_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_uint8(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_uint8(&ss))
}

//export Slice_uint8_set
func Slice_uint8_set(handle CGoHandle, _idx int, _vl C.uchar) {
	s := deptrFromHandle_Slice_uint8(handle)
	s[_idx] = uint8(_vl)
}

//export Slice_uint8_append
func Slice_uint8_append(handle CGoHandle, _vl C.uchar) {
	s := ptrFromHandle_Slice_uint8(handle)
	*s = append(*s, uint8(_vl))
}

// ---- Package: codon ---

// ---- Types ---

// Converters for pointer handles for type: *codon.AminoAcid
func ptrFromHandle_Ptr_codon_AminoAcid(h CGoHandle) *codon.AminoAcid {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "*codon.AminoAcid")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(codon.AminoAcid{})).(*codon.AminoAcid)
}
func handleFromPtr_Ptr_codon_AminoAcid(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("*codon.AminoAcid", p))
}

// Converters for pointer handles for type: *codon.Codon
func ptrFromHandle_Ptr_codon_Codon(h CGoHandle) *codon.Codon {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "*codon.Codon")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(codon.Codon{})).(*codon.Codon)
}
func handleFromPtr_Ptr_codon_Codon(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("*codon.Codon", p))
}

// Converters for pointer handles for type: *codon.Stats
func ptrFromHandle_Ptr_codon_Stats(h CGoHandle) *codon.Stats {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "*codon.Stats")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(codon.Stats{})).(*codon.Stats)
}
func handleFromPtr_Ptr_codon_Stats(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("*codon.Stats", p))
}

// Converters for pointer handles for type: *codon.TranslationTable
func ptrFromHandle_Ptr_codon_TranslationTable(h CGoHandle) *codon.TranslationTable {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "*codon.TranslationTable")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(codon.TranslationTable{})).(*codon.TranslationTable)
}
func handleFromPtr_Ptr_codon_TranslationTable(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("*codon.TranslationTable", p))
}

// Converters for implicit pointer handles for type: []genbank.BaseCount
func ptrFromHandle_Slice_genbank_BaseCount(h CGoHandle) *[]genbank.BaseCount {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]genbank.BaseCount")
	if p == nil {
		return nil
	}
	return p.(*[]genbank.BaseCount)
}
func deptrFromHandle_Slice_genbank_BaseCount(h CGoHandle) []genbank.BaseCount {
	p := ptrFromHandle_Slice_genbank_BaseCount(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_genbank_BaseCount(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]genbank.BaseCount", p))
}

// --- wrapping slice: []genbank.BaseCount ---
//
//export Slice_genbank_BaseCount_CTor
func Slice_genbank_BaseCount_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_genbank_BaseCount(&[]genbank.BaseCount{}))
}

//export Slice_genbank_BaseCount_len
func Slice_genbank_BaseCount_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_genbank_BaseCount(handle))
}

//export Slice_genbank_BaseCount_elem
func Slice_genbank_BaseCount_elem(handle CGoHandle, _idx int) CGoHandle {
	s := deptrFromHandle_Slice_genbank_BaseCount(handle)
	return handleFromPtr_genbank_BaseCount(&(s[_idx]))
}

//export Slice_genbank_BaseCount_subslice
func Slice_genbank_BaseCount_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_genbank_BaseCount(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_genbank_BaseCount(&ss))
}

//export Slice_genbank_BaseCount_set
func Slice_genbank_BaseCount_set(handle CGoHandle, _idx int, _vl CGoHandle) {
	s := deptrFromHandle_Slice_genbank_BaseCount(handle)
	s[_idx] = *ptrFromHandle_genbank_BaseCount(_vl)
}

//export Slice_genbank_BaseCount_append
func Slice_genbank_BaseCount_append(handle CGoHandle, _vl CGoHandle) {
	s := ptrFromHandle_Slice_genbank_BaseCount(handle)
	*s = append(*s, *ptrFromHandle_genbank_BaseCount(_vl))
}

// Converters for implicit pointer handles for type: []genbank.Feature
func ptrFromHandle_Slice_genbank_Feature(h CGoHandle) *[]genbank.Feature {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]genbank.Feature")
	if p == nil {
		return nil
	}
	return p.(*[]genbank.Feature)
}
func deptrFromHandle_Slice_genbank_Feature(h CGoHandle) []genbank.Feature {
	p := ptrFromHandle_Slice_genbank_Feature(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_genbank_Feature(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]genbank.Feature", p))
}

// --- wrapping slice: []genbank.Feature ---
//
//export Slice_genbank_Feature_CTor
func Slice_genbank_Feature_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_genbank_Feature(&[]genbank.Feature{}))
}

//export Slice_genbank_Feature_len
func Slice_genbank_Feature_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_genbank_Feature(handle))
}

//export Slice_genbank_Feature_elem
func Slice_genbank_Feature_elem(handle CGoHandle, _idx int) CGoHandle {
	s := deptrFromHandle_Slice_genbank_Feature(handle)
	return handleFromPtr_genbank_Feature(&(s[_idx]))
}

//export Slice_genbank_Feature_subslice
func Slice_genbank_Feature_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_genbank_Feature(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_genbank_Feature(&ss))
}

//export Slice_genbank_Feature_set
func Slice_genbank_Feature_set(handle CGoHandle, _idx int, _vl CGoHandle) {
	s := deptrFromHandle_Slice_genbank_Feature(handle)
	s[_idx] = *ptrFromHandle_genbank_Feature(_vl)
}

//export Slice_genbank_Feature_append
func Slice_genbank_Feature_append(handle CGoHandle, _vl CGoHandle) {
	s := ptrFromHandle_Slice_genbank_Feature(handle)
	*s = append(*s, *ptrFromHandle_genbank_Feature(_vl))
}

// Converters for implicit pointer handles for type: []genbank.Location
func ptrFromHandle_Slice_genbank_Location(h CGoHandle) *[]genbank.Location {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]genbank.Location")
	if p == nil {
		return nil
	}
	return p.(*[]genbank.Location)
}
func deptrFromHandle_Slice_genbank_Location(h CGoHandle) []genbank.Location {
	p := ptrFromHandle_Slice_genbank_Location(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_genbank_Location(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]genbank.Location", p))
}

// --- wrapping slice: []genbank.Location ---
//
//export Slice_genbank_Location_CTor
func Slice_genbank_Location_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_genbank_Location(&[]genbank.Location{}))
}

//export Slice_genbank_Location_len
func Slice_genbank_Location_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_genbank_Location(handle))
}

//export Slice_genbank_Location_elem
func Slice_genbank_Location_elem(handle CGoHandle, _idx int) CGoHandle {
	s := deptrFromHandle_Slice_genbank_Location(handle)
	return handleFromPtr_genbank_Location(&(s[_idx]))
}

//export Slice_genbank_Location_subslice
func Slice_genbank_Location_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_genbank_Location(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_genbank_Location(&ss))
}

//export Slice_genbank_Location_set
func Slice_genbank_Location_set(handle CGoHandle, _idx int, _vl CGoHandle) {
	s := deptrFromHandle_Slice_genbank_Location(handle)
	s[_idx] = *ptrFromHandle_genbank_Location(_vl)
}

//export Slice_genbank_Location_append
func Slice_genbank_Location_append(handle CGoHandle, _vl CGoHandle) {
	s := ptrFromHandle_Slice_genbank_Location(handle)
	*s = append(*s, *ptrFromHandle_genbank_Location(_vl))
}

// Converters for implicit pointer handles for type: []genbank.Reference
func ptrFromHandle_Slice_genbank_Reference(h CGoHandle) *[]genbank.Reference {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]genbank.Reference")
	if p == nil {
		return nil
	}
	return p.(*[]genbank.Reference)
}
func deptrFromHandle_Slice_genbank_Reference(h CGoHandle) []genbank.Reference {
	p := ptrFromHandle_Slice_genbank_Reference(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_genbank_Reference(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]genbank.Reference", p))
}

// --- wrapping slice: []genbank.Reference ---
//
//export Slice_genbank_Reference_CTor
func Slice_genbank_Reference_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_genbank_Reference(&[]genbank.Reference{}))
}

//export Slice_genbank_Reference_len
func Slice_genbank_Reference_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_genbank_Reference(handle))
}

//export Slice_genbank_Reference_elem
func Slice_genbank_Reference_elem(handle CGoHandle, _idx int) CGoHandle {
	s := deptrFromHandle_Slice_genbank_Reference(handle)
	return handleFromPtr_genbank_Reference(&(s[_idx]))
}

//export Slice_genbank_Reference_subslice
func Slice_genbank_Reference_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_genbank_Reference(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_genbank_Reference(&ss))
}

//export Slice_genbank_Reference_set
func Slice_genbank_Reference_set(handle CGoHandle, _idx int, _vl CGoHandle) {
	s := deptrFromHandle_Slice_genbank_Reference(handle)
	s[_idx] = *ptrFromHandle_genbank_Reference(_vl)
}

//export Slice_genbank_Reference_append
func Slice_genbank_Reference_append(handle CGoHandle, _vl CGoHandle) {
	s := ptrFromHandle_Slice_genbank_Reference(handle)
	*s = append(*s, *ptrFromHandle_genbank_Reference(_vl))
}

// Converters for implicit pointer handles for type: []codon.AminoAcid
func ptrFromHandle_Slice_codon_AminoAcid(h CGoHandle) *[]codon.AminoAcid {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]codon.AminoAcid")
	if p == nil {
		return nil
	}
	return p.(*[]codon.AminoAcid)
}
func deptrFromHandle_Slice_codon_AminoAcid(h CGoHandle) []codon.AminoAcid {
	p := ptrFromHandle_Slice_codon_AminoAcid(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_codon_AminoAcid(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]codon.AminoAcid", p))
}

// --- wrapping slice: []codon.AminoAcid ---
//
//export Slice_codon_AminoAcid_CTor
func Slice_codon_AminoAcid_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_codon_AminoAcid(&[]codon.AminoAcid{}))
}

//export Slice_codon_AminoAcid_len
func Slice_codon_AminoAcid_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_codon_AminoAcid(handle))
}

//export Slice_codon_AminoAcid_elem
func Slice_codon_AminoAcid_elem(handle CGoHandle, _idx int) CGoHandle {
	s := deptrFromHandle_Slice_codon_AminoAcid(handle)
	return handleFromPtr_codon_AminoAcid(&(s[_idx]))
}

//export Slice_codon_AminoAcid_subslice
func Slice_codon_AminoAcid_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_codon_AminoAcid(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_codon_AminoAcid(&ss))
}

//export Slice_codon_AminoAcid_set
func Slice_codon_AminoAcid_set(handle CGoHandle, _idx int, _vl CGoHandle) {
	s := deptrFromHandle_Slice_codon_AminoAcid(handle)
	s[_idx] = *ptrFromHandle_codon_AminoAcid(_vl)
}

//export Slice_codon_AminoAcid_append
func Slice_codon_AminoAcid_append(handle CGoHandle, _vl CGoHandle) {
	s := ptrFromHandle_Slice_codon_AminoAcid(handle)
	*s = append(*s, *ptrFromHandle_codon_AminoAcid(_vl))
}

// Converters for implicit pointer handles for type: []codon.Codon
func ptrFromHandle_Slice_codon_Codon(h CGoHandle) *[]codon.Codon {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]codon.Codon")
	if p == nil {
		return nil
	}
	return p.(*[]codon.Codon)
}
func deptrFromHandle_Slice_codon_Codon(h CGoHandle) []codon.Codon {
	p := ptrFromHandle_Slice_codon_Codon(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_codon_Codon(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]codon.Codon", p))
}

// --- wrapping slice: []codon.Codon ---
//
//export Slice_codon_Codon_CTor
func Slice_codon_Codon_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_codon_Codon(&[]codon.Codon{}))
}

//export Slice_codon_Codon_len
func Slice_codon_Codon_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_codon_Codon(handle))
}

//export Slice_codon_Codon_elem
func Slice_codon_Codon_elem(handle CGoHandle, _idx int) CGoHandle {
	s := deptrFromHandle_Slice_codon_Codon(handle)
	return handleFromPtr_codon_Codon(&(s[_idx]))
}

//export Slice_codon_Codon_subslice
func Slice_codon_Codon_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_codon_Codon(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_codon_Codon(&ss))
}

//export Slice_codon_Codon_set
func Slice_codon_Codon_set(handle CGoHandle, _idx int, _vl CGoHandle) {
	s := deptrFromHandle_Slice_codon_Codon(handle)
	s[_idx] = *ptrFromHandle_codon_Codon(_vl)
}

//export Slice_codon_Codon_append
func Slice_codon_Codon_append(handle CGoHandle, _vl CGoHandle) {
	s := ptrFromHandle_Slice_codon_Codon(handle)
	*s = append(*s, *ptrFromHandle_codon_Codon(_vl))
}

// Converters for non-pointer handles for type: codon.AminoAcid
func ptrFromHandle_codon_AminoAcid(h CGoHandle) *codon.AminoAcid {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "codon.AminoAcid")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(codon.AminoAcid{})).(*codon.AminoAcid)
}
func handleFromPtr_codon_AminoAcid(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("codon.AminoAcid", p))
}

// Converters for non-pointer handles for type: codon.Codon
func ptrFromHandle_codon_Codon(h CGoHandle) *codon.Codon {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "codon.Codon")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(codon.Codon{})).(*codon.Codon)
}
func handleFromPtr_codon_Codon(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("codon.Codon", p))
}

// Converters for non-pointer handles for type: codon.Stats
func ptrFromHandle_codon_Stats(h CGoHandle) *codon.Stats {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "codon.Stats")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(codon.Stats{})).(*codon.Stats)
}
func handleFromPtr_codon_Stats(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("codon.Stats", p))
}

// Converters for pointer handles for type: codon.Table
func ptrFromHandle_codon_Table(h CGoHandle) codon.Table {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "codon.Table")
	if p == nil {
		return nil
	}
	return p.(codon.Table)
}
func handleFromPtr_codon_Table(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("codon.Table", p))
}

// Converters for non-pointer handles for type: codon.TranslationTable
func ptrFromHandle_codon_TranslationTable(h CGoHandle) *codon.TranslationTable {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "codon.TranslationTable")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(codon.TranslationTable{})).(*codon.TranslationTable)
}
func handleFromPtr_codon_TranslationTable(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("codon.TranslationTable", p))
}

// Converters for implicit pointer handles for type: map[string]weightedrand.Chooser
func ptrFromHandle_Map_string_weightedrand_Chooser(h CGoHandle) *map[string]weightedrand.Chooser {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "map[string]weightedrand.Chooser")
	if p == nil {
		return nil
	}
	return p.(*map[string]weightedrand.Chooser)
}
func deptrFromHandle_Map_string_weightedrand_Chooser(h CGoHandle) map[string]weightedrand.Chooser {
	p := ptrFromHandle_Map_string_weightedrand_Chooser(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Map_string_weightedrand_Chooser(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("map[string]weightedrand.Chooser", p))
}

// --- wrapping map: map[string]weightedrand.Chooser ---
//
//export Map_string_weightedrand_Chooser_CTor
func Map_string_weightedrand_Chooser_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Map_string_weightedrand_Chooser(&map[string]weightedrand.Chooser{}))
}

//export Map_string_weightedrand_Chooser_len
func Map_string_weightedrand_Chooser_len(handle CGoHandle) int {
	return len(deptrFromHandle_Map_string_weightedrand_Chooser(handle))
}

//export Map_string_weightedrand_Chooser_elem
func Map_string_weightedrand_Chooser_elem(handle CGoHandle, _ky *C.char) CGoHandle {
	s := deptrFromHandle_Map_string_weightedrand_Chooser(handle)
	v, ok := s[C.GoString(_ky)]
	if !ok {
		C.PyErr_SetString(C.PyExc_KeyError, C.CString("key not in map"))
	}
	return handleFromPtr_weightedrand_Chooser(&v)
}

//export Map_string_weightedrand_Chooser_contains
func Map_string_weightedrand_Chooser_contains(handle CGoHandle, _ky *C.char) C.char {
	s := deptrFromHandle_Map_string_weightedrand_Chooser(handle)
	_, ok := s[C.GoString(_ky)]
	return boolGoToPy(ok)
}

//export Map_string_weightedrand_Chooser_set
func Map_string_weightedrand_Chooser_set(handle CGoHandle, _ky *C.char, _vl CGoHandle) {
	s := deptrFromHandle_Map_string_weightedrand_Chooser(handle)
	s[C.GoString(_ky)] = *ptrFromHandle_weightedrand_Chooser(_vl)
}

//export Map_string_weightedrand_Chooser_delete
func Map_string_weightedrand_Chooser_delete(handle CGoHandle, _ky *C.char) {
	s := deptrFromHandle_Map_string_weightedrand_Chooser(handle)
	delete(s, C.GoString(_ky))
}

//export Map_string_weightedrand_Chooser_keys
func Map_string_weightedrand_Chooser_keys(handle CGoHandle) CGoHandle {
	s := deptrFromHandle_Map_string_weightedrand_Chooser(handle)
	kys := make([]string, 0, len(s))
	for k := range s {
		kys = append(kys, k)
	}
	return handleFromPtr_Slice_string(&kys)
}

// Converters for implicit pointer handles for type: map[string]int
func ptrFromHandle_Map_string_int(h CGoHandle) *map[string]int {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "map[string]int")
	if p == nil {
		return nil
	}
	return p.(*map[string]int)
}
func deptrFromHandle_Map_string_int(h CGoHandle) map[string]int {
	p := ptrFromHandle_Map_string_int(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Map_string_int(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("map[string]int", p))
}

// --- wrapping map: map[string]int ---
//
//export Map_string_int_CTor
func Map_string_int_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Map_string_int(&map[string]int{}))
}

//export Map_string_int_len
func Map_string_int_len(handle CGoHandle) int {
	return len(deptrFromHandle_Map_string_int(handle))
}

//export Map_string_int_elem
func Map_string_int_elem(handle CGoHandle, _ky *C.char) C.longlong {
	s := deptrFromHandle_Map_string_int(handle)
	v, ok := s[C.GoString(_ky)]
	if !ok {
		C.PyErr_SetString(C.PyExc_KeyError, C.CString("key not in map"))
	}
	return C.longlong(v)
}

//export Map_string_int_contains
func Map_string_int_contains(handle CGoHandle, _ky *C.char) C.char {
	s := deptrFromHandle_Map_string_int(handle)
	_, ok := s[C.GoString(_ky)]
	return boolGoToPy(ok)
}

//export Map_string_int_set
func Map_string_int_set(handle CGoHandle, _ky *C.char, _vl C.longlong) {
	s := deptrFromHandle_Map_string_int(handle)
	s[C.GoString(_ky)] = int(_vl)
}

//export Map_string_int_delete
func Map_string_int_delete(handle CGoHandle, _ky *C.char) {
	s := deptrFromHandle_Map_string_int(handle)
	delete(s, C.GoString(_ky))
}

//export Map_string_int_keys
func Map_string_int_keys(handle CGoHandle) CGoHandle {
	s := deptrFromHandle_Map_string_int(handle)
	kys := make([]string, 0, len(s))
	for k := range s {
		kys = append(kys, k)
	}
	return handleFromPtr_Slice_string(&kys)
}

// Converters for implicit pointer handles for type: map[string]string
func ptrFromHandle_Map_string_string(h CGoHandle) *map[string]string {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "map[string]string")
	if p == nil {
		return nil
	}
	return p.(*map[string]string)
}
func deptrFromHandle_Map_string_string(h CGoHandle) map[string]string {
	p := ptrFromHandle_Map_string_string(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Map_string_string(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("map[string]string", p))
}

// --- wrapping map: map[string]string ---
//
//export Map_string_string_CTor
func Map_string_string_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Map_string_string(&map[string]string{}))
}

//export Map_string_string_len
func Map_string_string_len(handle CGoHandle) int {
	return len(deptrFromHandle_Map_string_string(handle))
}

//export Map_string_string_elem
func Map_string_string_elem(handle CGoHandle, _ky *C.char) *C.char {
	s := deptrFromHandle_Map_string_string(handle)
	v, ok := s[C.GoString(_ky)]
	if !ok {
		C.PyErr_SetString(C.PyExc_KeyError, C.CString("key not in map"))
	}
	return C.CString(v)
}

//export Map_string_string_contains
func Map_string_string_contains(handle CGoHandle, _ky *C.char) C.char {
	s := deptrFromHandle_Map_string_string(handle)
	_, ok := s[C.GoString(_ky)]
	return boolGoToPy(ok)
}

//export Map_string_string_set
func Map_string_string_set(handle CGoHandle, _ky *C.char, _vl *C.char) {
	s := deptrFromHandle_Map_string_string(handle)
	s[C.GoString(_ky)] = C.GoString(_vl)
}

//export Map_string_string_delete
func Map_string_string_delete(handle CGoHandle, _ky *C.char) {
	s := deptrFromHandle_Map_string_string(handle)
	delete(s, C.GoString(_ky))
}

//export Map_string_string_keys
func Map_string_string_keys(handle CGoHandle) CGoHandle {
	s := deptrFromHandle_Map_string_string(handle)
	kys := make([]string, 0, len(s))
	for k := range s {
		kys = append(kys, k)
	}
	return handleFromPtr_Slice_string(&kys)
}

// ---- Global Variables: can only use functions to access ---

// ---- Interfaces ---

//export codon_Table_GetWeightedAminoAcids
func codon_Table_GetWeightedAminoAcids(_handle CGoHandle) CGoHandle {
	_saved_thread := C.PyEval_SaveThread()
	defer C.PyEval_RestoreThread(_saved_thread)
	vifc, __err := gopyh.VarFromHandleTry((gopyh.CGoHandle)(_handle), "codon.Table")
	if __err != nil {
		return handleFromPtr_Slice_codon_AminoAcid(nil)
	}
	cret := vifc.(codon.Table).GetWeightedAminoAcids()

	return handleFromPtr_Slice_codon_AminoAcid(&cret)
}

//export codon_Table_Optimize
func codon_Table_Optimize(_handle CGoHandle, aminoAcids *C.char, randomState CGoHandle) *C.char {
	_saved_thread := C.PyEval_SaveThread()
	vifc, __err := gopyh.VarFromHandleTry((gopyh.CGoHandle)(_handle), "codon.Table")
	if __err != nil {
		return C.CString("")
	}
	cret, __err := vifc.(codon.Table).Optimize(C.GoString(aminoAcids), deptrFromHandle_Slice_int(randomState)...)

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return C.CString("")
	}
	return C.CString(cret)
}

//export codon_Table_Translate
func codon_Table_Translate(_handle CGoHandle, dnaSeq *C.char) *C.char {
	_saved_thread := C.PyEval_SaveThread()
	vifc, __err := gopyh.VarFromHandleTry((gopyh.CGoHandle)(_handle), "codon.Table")
	if __err != nil {
		return C.CString("")
	}
	cret, __err := vifc.(codon.Table).Translate(C.GoString(dnaSeq))

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return C.CString("")
	}
	return C.CString(cret)
}

// ---- Structs ---

// --- wrapping struct: codon.AminoAcid ---
//
//export codon_AminoAcid_CTor
func codon_AminoAcid_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_codon_AminoAcid(&codon.AminoAcid{}))
}

//export codon_AminoAcid_Letter_Get
func codon_AminoAcid_Letter_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_codon_AminoAcid(handle)
	return C.CString(op.Letter)
}

//export codon_AminoAcid_Letter_Set
func codon_AminoAcid_Letter_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_codon_AminoAcid(handle)
	op.Letter = C.GoString(val)
}

//export codon_AminoAcid_Codons_Get
func codon_AminoAcid_Codons_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_codon_AminoAcid(handle)
	return handleFromPtr_Slice_codon_Codon(&op.Codons)
}

//export codon_AminoAcid_Codons_Set
func codon_AminoAcid_Codons_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_codon_AminoAcid(handle)
	op.Codons = deptrFromHandle_Slice_codon_Codon(val)
}

// --- wrapping struct: codon.Codon ---
//
//export codon_Codon_CTor
func codon_Codon_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_codon_Codon(&codon.Codon{}))
}

//export codon_Codon_Triplet_Get
func codon_Codon_Triplet_Get(handle CGoHandle) *C.char {
	op := ptrFromHandle_codon_Codon(handle)
	return C.CString(op.Triplet)
}

//export codon_Codon_Triplet_Set
func codon_Codon_Triplet_Set(handle CGoHandle, val *C.char) {
	op := ptrFromHandle_codon_Codon(handle)
	op.Triplet = C.GoString(val)
}

//export codon_Codon_Weight_Get
func codon_Codon_Weight_Get(handle CGoHandle) C.longlong {
	op := ptrFromHandle_codon_Codon(handle)
	return C.longlong(op.Weight)
}

//export codon_Codon_Weight_Set
func codon_Codon_Weight_Set(handle CGoHandle, val C.longlong) {
	op := ptrFromHandle_codon_Codon(handle)
	op.Weight = int(val)
}

// --- wrapping struct: codon.Stats ---
//
//export codon_Stats_CTor
func codon_Stats_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_codon_Stats(&codon.Stats{}))
}

//export codon_Stats_StartCodonCount_Get
func codon_Stats_StartCodonCount_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_codon_Stats(handle)
	return handleFromPtr_Map_string_int(&op.StartCodonCount)
}

//export codon_Stats_StartCodonCount_Set
func codon_Stats_StartCodonCount_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_codon_Stats(handle)
	op.StartCodonCount = deptrFromHandle_Map_string_int(val)
}

//export codon_Stats_GeneCount_Get
func codon_Stats_GeneCount_Get(handle CGoHandle) C.longlong {
	op := ptrFromHandle_codon_Stats(handle)
	return C.longlong(op.GeneCount)
}

//export codon_Stats_GeneCount_Set
func codon_Stats_GeneCount_Set(handle CGoHandle, val C.longlong) {
	op := ptrFromHandle_codon_Stats(handle)
	op.GeneCount = int(val)
}

// --- wrapping struct: codon.TranslationTable ---
//
//export codon_TranslationTable_CTor
func codon_TranslationTable_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_codon_TranslationTable(&codon.TranslationTable{}))
}

//export codon_TranslationTable_StartCodons_Get
func codon_TranslationTable_StartCodons_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_codon_TranslationTable(handle)
	return handleFromPtr_Slice_string(&op.StartCodons)
}

//export codon_TranslationTable_StartCodons_Set
func codon_TranslationTable_StartCodons_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_codon_TranslationTable(handle)
	op.StartCodons = deptrFromHandle_Slice_string(val)
}

//export codon_TranslationTable_StopCodons_Get
func codon_TranslationTable_StopCodons_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_codon_TranslationTable(handle)
	return handleFromPtr_Slice_string(&op.StopCodons)
}

//export codon_TranslationTable_StopCodons_Set
func codon_TranslationTable_StopCodons_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_codon_TranslationTable(handle)
	op.StopCodons = deptrFromHandle_Slice_string(val)
}

//export codon_TranslationTable_AminoAcids_Get
func codon_TranslationTable_AminoAcids_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_codon_TranslationTable(handle)
	return handleFromPtr_Slice_codon_AminoAcid(&op.AminoAcids)
}

//export codon_TranslationTable_AminoAcids_Set
func codon_TranslationTable_AminoAcids_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_codon_TranslationTable(handle)
	op.AminoAcids = deptrFromHandle_Slice_codon_AminoAcid(val)
}

//export codon_TranslationTable_TranslationMap_Get
func codon_TranslationTable_TranslationMap_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_codon_TranslationTable(handle)
	return handleFromPtr_Map_string_string(&op.TranslationMap)
}

//export codon_TranslationTable_TranslationMap_Set
func codon_TranslationTable_TranslationMap_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_codon_TranslationTable(handle)
	op.TranslationMap = deptrFromHandle_Map_string_string(val)
}

//export codon_TranslationTable_StartCodonTable_Get
func codon_TranslationTable_StartCodonTable_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_codon_TranslationTable(handle)
	return handleFromPtr_Map_string_string(&op.StartCodonTable)
}

//export codon_TranslationTable_StartCodonTable_Set
func codon_TranslationTable_StartCodonTable_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_codon_TranslationTable(handle)
	op.StartCodonTable = deptrFromHandle_Map_string_string(val)
}

//export codon_TranslationTable_Choosers_Get
func codon_TranslationTable_Choosers_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_codon_TranslationTable(handle)
	return handleFromPtr_Map_string_weightedrand_Chooser(&op.Choosers)
}

//export codon_TranslationTable_Choosers_Set
func codon_TranslationTable_Choosers_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_codon_TranslationTable(handle)
	op.Choosers = deptrFromHandle_Map_string_weightedrand_Chooser(val)
}

//export codon_TranslationTable_Stats_Get
func codon_TranslationTable_Stats_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_codon_TranslationTable(handle)
	return handleFromPtr_Ptr_codon_Stats(op.Stats)
}

//export codon_TranslationTable_Stats_Set
func codon_TranslationTable_Stats_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_codon_TranslationTable(handle)
	op.Stats = ptrFromHandle_Ptr_codon_Stats(val)
}

//export codon_TranslationTable_Copy
func codon_TranslationTable_Copy(_handle CGoHandle) CGoHandle {
	_saved_thread := C.PyEval_SaveThread()
	vifc, __err := gopyh.VarFromHandleTry((gopyh.CGoHandle)(_handle), "*codon.TranslationTable")
	if __err != nil {
		return handleFromPtr_Ptr_codon_TranslationTable(nil)
	}
	cret, __err := gopyh.Embed(vifc, reflect.TypeOf(codon.TranslationTable{})).(*codon.TranslationTable).Copy()

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return handleFromPtr_Ptr_codon_TranslationTable(nil)
	}
	return handleFromPtr_Ptr_codon_TranslationTable(cret)
}

//export codon_TranslationTable_GetWeightedAminoAcids
func codon_TranslationTable_GetWeightedAminoAcids(_handle CGoHandle) CGoHandle {
	_saved_thread := C.PyEval_SaveThread()
	defer C.PyEval_RestoreThread(_saved_thread)
	vifc, __err := gopyh.VarFromHandleTry((gopyh.CGoHandle)(_handle), "*codon.TranslationTable")
	if __err != nil {
		return handleFromPtr_Slice_codon_AminoAcid(nil)
	}
	cret := gopyh.Embed(vifc, reflect.TypeOf(codon.TranslationTable{})).(*codon.TranslationTable).GetWeightedAminoAcids()

	return handleFromPtr_Slice_codon_AminoAcid(&cret)
}

//export codon_TranslationTable_Optimize
func codon_TranslationTable_Optimize(_handle CGoHandle, aminoAcids *C.char, randomState CGoHandle) *C.char {
	_saved_thread := C.PyEval_SaveThread()
	vifc, __err := gopyh.VarFromHandleTry((gopyh.CGoHandle)(_handle), "*codon.TranslationTable")
	if __err != nil {
		return C.CString("")
	}
	cret, __err := gopyh.Embed(vifc, reflect.TypeOf(codon.TranslationTable{})).(*codon.TranslationTable).Optimize(C.GoString(aminoAcids), deptrFromHandle_Slice_int(randomState)...)

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return C.CString("")
	}
	return C.CString(cret)
}

//export codon_TranslationTable_UpdateWeights
func codon_TranslationTable_UpdateWeights(_handle CGoHandle, aminoAcids CGoHandle) *C.char {
	_saved_thread := C.PyEval_SaveThread()
	vifc, __err := gopyh.VarFromHandleTry((gopyh.CGoHandle)(_handle), "*codon.TranslationTable")
	if __err != nil {
		return errorGoToPy(nil)
	}
	__err = gopyh.Embed(vifc, reflect.TypeOf(codon.TranslationTable{})).(*codon.TranslationTable).UpdateWeights(deptrFromHandle_Slice_codon_AminoAcid(aminoAcids))

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		return estr
	}
	return C.CString("")
}

//export codon_TranslationTable_UpdateWeightsWithSequence
func codon_TranslationTable_UpdateWeightsWithSequence(_handle CGoHandle, data CGoHandle) *C.char {
	_saved_thread := C.PyEval_SaveThread()
	vifc, __err := gopyh.VarFromHandleTry((gopyh.CGoHandle)(_handle), "*codon.TranslationTable")
	if __err != nil {
		return errorGoToPy(nil)
	}
	__err = gopyh.Embed(vifc, reflect.TypeOf(codon.TranslationTable{})).(*codon.TranslationTable).UpdateWeightsWithSequence(*ptrFromHandle_genbank_Genbank(data))

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		return estr
	}
	return C.CString("")
}

//export codon_TranslationTable_Translate
func codon_TranslationTable_Translate(_handle CGoHandle, dnaSeq *C.char) *C.char {
	_saved_thread := C.PyEval_SaveThread()
	vifc, __err := gopyh.VarFromHandleTry((gopyh.CGoHandle)(_handle), "*codon.TranslationTable")
	if __err != nil {
		return C.CString("")
	}
	cret, __err := gopyh.Embed(vifc, reflect.TypeOf(codon.TranslationTable{})).(*codon.TranslationTable).Translate(C.GoString(dnaSeq))

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return C.CString("")
	}
	return C.CString(cret)
}

// ---- Slices ---

// ---- Maps ---

// ---- Constructors ---

//export codon_NewStats
func codon_NewStats() CGoHandle {
	_saved_thread := C.PyEval_SaveThread()
	defer C.PyEval_RestoreThread(_saved_thread)
	return handleFromPtr_Ptr_codon_Stats(codon.NewStats())

}

//export codon_ReadCodonJSON
func codon_ReadCodonJSON(path *C.char) CGoHandle {
	_saved_thread := C.PyEval_SaveThread()
	defer C.PyEval_RestoreThread(_saved_thread)
	return handleFromPtr_Ptr_codon_TranslationTable(codon.ReadCodonJSON(C.GoString(path)))

}

//export codon_AddCodonTable
func codon_AddCodonTable(firstCodonTable CGoHandle, secondCodonTable CGoHandle) CGoHandle {
	_saved_thread := C.PyEval_SaveThread()
	cret, __err := codon.AddCodonTable(ptrFromHandle_Ptr_codon_TranslationTable(firstCodonTable), ptrFromHandle_Ptr_codon_TranslationTable(secondCodonTable))

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return handleFromPtr_Ptr_codon_TranslationTable(nil)
	}
	return handleFromPtr_Ptr_codon_TranslationTable(cret)
}

//export codon_CompromiseCodonTable
func codon_CompromiseCodonTable(firstCodonTable CGoHandle, secondCodonTable CGoHandle, cutOff C.double) CGoHandle {
	_saved_thread := C.PyEval_SaveThread()
	cret, __err := codon.CompromiseCodonTable(ptrFromHandle_Ptr_codon_TranslationTable(firstCodonTable), ptrFromHandle_Ptr_codon_TranslationTable(secondCodonTable), float64(cutOff))

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return handleFromPtr_Ptr_codon_TranslationTable(nil)
	}
	return handleFromPtr_Ptr_codon_TranslationTable(cret)
}

//export codon_NewTranslationTable
func codon_NewTranslationTable(index C.longlong) CGoHandle {
	_saved_thread := C.PyEval_SaveThread()
	cret, __err := codon.NewTranslationTable(int(index))

	C.PyEval_RestoreThread(_saved_thread)
	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return handleFromPtr_Ptr_codon_TranslationTable(nil)
	}
	return handleFromPtr_Ptr_codon_TranslationTable(cret)
}

//export codon_ParseCodonJSON
func codon_ParseCodonJSON(file CGoHandle) CGoHandle {
	_saved_thread := C.PyEval_SaveThread()
	defer C.PyEval_RestoreThread(_saved_thread)
	return handleFromPtr_Ptr_codon_TranslationTable(codon.ParseCodonJSON(deptrFromHandle_Slice_byte(file)))

}

// ---- Functions ---

//export codon_WriteCodonJSON
func codon_WriteCodonJSON(codonTable CGoHandle, path *C.char, goRun C.char) {
	_saved_thread := C.PyEval_SaveThread()
	defer C.PyEval_RestoreThread(_saved_thread)
	if boolPyToGo(goRun) {
		go codon.WriteCodonJSON(ptrFromHandle_Ptr_codon_TranslationTable(codonTable), C.GoString(path))
	} else {
		codon.WriteCodonJSON(ptrFromHandle_Ptr_codon_TranslationTable(codonTable), C.GoString(path))
	}
}
