# python build stubs for package uniprot
# File is generated by gopy. Do not edit.
# gopy build -output=poly/io/uniprot -vm=python3 github.com/bebop/poly/io/uniprot

from pybindgen import retval, param, Function, Module
import sys

class CheckedFunction(Function):
    def __init__(self, *a, **kw):
        super(CheckedFunction, self).__init__(*a, **kw)
        self._failure_expression = kw.get('failure_expression', '')
        self._failure_cleanup = kw.get('failure_cleanup', '')

    def set_failure_expression(self, expr):
        self._failure_expression = expr

    def set_failure_cleanup(self, expr):
        self._failure_cleanup = expr

    def generate_call(self):
        super(CheckedFunction, self).generate_call()
        check = "PyErr_Occurred()"
        if self._failure_expression:
            check = "{} && {}".format(self._failure_expression, check)
        failure_cleanup = self._failure_cleanup or None
        self.before_call.write_error_check(check, failure_cleanup)

def add_checked_function(mod, name, retval, params, failure_expression='', *a, **kw):
    fn = CheckedFunction(name, retval, params, *a, **kw)
    fn.set_failure_expression(failure_expression)
    mod._add_function_obj(fn)
    return fn

def add_checked_string_function(mod, name, retval, params, failure_expression='', *a, **kw):
    fn = CheckedFunction(name, retval, params, *a, **kw)
    fn.set_failure_cleanup('if (retval != NULL) free(retval);')
    fn.after_call.add_cleanup_code('free(retval);')
    fn.set_failure_expression(failure_expression)
    mod._add_function_obj(fn)
    return fn

mod = Module('_uniprot')
mod.add_include('"uniprot_go.h"')
mod.add_function('GoPyInit', None, [])
mod.add_function('DecRef', None, [param('int64_t', 'handle')])
mod.add_function('IncRef', None, [param('int64_t', 'handle')])
mod.add_function('NumHandles', retval('int'), [])
mod.add_function('Slice_bool_CTor', retval('int64_t'), [])
mod.add_function('Slice_bool_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_bool_elem', retval('bool'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_bool_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_bool_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('bool', 'value')])
mod.add_function('Slice_bool_append', None, [param('int64_t', 'handle'), param('bool', 'value')])
mod.add_function('Slice_byte_CTor', retval('int64_t'), [])
mod.add_function('Slice_byte_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_byte_elem', retval('uint8_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_byte_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_byte_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint8_t', 'value')])
mod.add_function('Slice_byte_append', None, [param('int64_t', 'handle'), param('uint8_t', 'value')])
mod.add_function('Slice_byte_from_bytes', retval('int64_t'), [param('PyObject*', 'o', transfer_ownership=False)])
mod.add_function('Slice_byte_to_bytes', retval('PyObject*', caller_owns_return=True), [param('int64_t', 'handle')])
mod.add_function('Slice_error_CTor', retval('int64_t'), [])
mod.add_function('Slice_error_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_error_elem', retval('char*'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_error_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_error_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('char*', 'value')])
mod.add_function('Slice_error_append', None, [param('int64_t', 'handle'), param('char*', 'value')])
mod.add_function('Slice_float32_CTor', retval('int64_t'), [])
mod.add_function('Slice_float32_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_float32_elem', retval('float'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_float32_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_float32_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('float', 'value')])
mod.add_function('Slice_float32_append', None, [param('int64_t', 'handle'), param('float', 'value')])
mod.add_function('Slice_float64_CTor', retval('int64_t'), [])
mod.add_function('Slice_float64_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_float64_elem', retval('double'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_float64_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_float64_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('double', 'value')])
mod.add_function('Slice_float64_append', None, [param('int64_t', 'handle'), param('double', 'value')])
mod.add_function('Slice_int_CTor', retval('int64_t'), [])
mod.add_function('Slice_int_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_int_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_int16_CTor', retval('int64_t'), [])
mod.add_function('Slice_int16_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int16_elem', retval('int16_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int16_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int16_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int16_t', 'value')])
mod.add_function('Slice_int16_append', None, [param('int64_t', 'handle'), param('int16_t', 'value')])
mod.add_function('Slice_int32_CTor', retval('int64_t'), [])
mod.add_function('Slice_int32_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int32_elem', retval('int32_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int32_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int32_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int32_t', 'value')])
mod.add_function('Slice_int32_append', None, [param('int64_t', 'handle'), param('int32_t', 'value')])
mod.add_function('Slice_int64_CTor', retval('int64_t'), [])
mod.add_function('Slice_int64_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int64_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int64_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int64_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_int64_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_int8_CTor', retval('int64_t'), [])
mod.add_function('Slice_int8_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int8_elem', retval('int8_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int8_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int8_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int8_t', 'value')])
mod.add_function('Slice_int8_append', None, [param('int64_t', 'handle'), param('int8_t', 'value')])
mod.add_function('Slice_rune_CTor', retval('int64_t'), [])
mod.add_function('Slice_rune_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_rune_elem', retval('int32_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_rune_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_rune_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int32_t', 'value')])
mod.add_function('Slice_rune_append', None, [param('int64_t', 'handle'), param('int32_t', 'value')])
mod.add_function('Slice_string_CTor', retval('int64_t'), [])
mod.add_function('Slice_string_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_string_elem', retval('char*'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_string_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_string_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('char*', 'value')])
mod.add_function('Slice_string_append', None, [param('int64_t', 'handle'), param('char*', 'value')])
mod.add_function('Slice_uint_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint_elem', retval('uint64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint64_t', 'value')])
mod.add_function('Slice_uint_append', None, [param('int64_t', 'handle'), param('uint64_t', 'value')])
mod.add_function('Slice_uint16_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint16_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint16_elem', retval('uint16_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint16_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint16_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint16_t', 'value')])
mod.add_function('Slice_uint16_append', None, [param('int64_t', 'handle'), param('uint16_t', 'value')])
mod.add_function('Slice_uint32_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint32_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint32_elem', retval('uint32_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint32_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint32_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint32_t', 'value')])
mod.add_function('Slice_uint32_append', None, [param('int64_t', 'handle'), param('uint32_t', 'value')])
mod.add_function('Slice_uint64_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint64_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint64_elem', retval('uint64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint64_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint64_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint64_t', 'value')])
mod.add_function('Slice_uint64_append', None, [param('int64_t', 'handle'), param('uint64_t', 'value')])
mod.add_function('Slice_uint8_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint8_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint8_elem', retval('uint8_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint8_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint8_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint8_t', 'value')])
mod.add_function('Slice_uint8_append', None, [param('int64_t', 'handle'), param('uint8_t', 'value')])
mod.add_function('Slice_xml_Attr_CTor', retval('int64_t'), [])
mod.add_function('Slice_xml_Attr_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_xml_Attr_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_xml_Attr_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_xml_Attr_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_xml_Attr_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_AlternativeName_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_AlternativeName_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_AlternativeName_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_AlternativeName_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_AlternativeName_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_AlternativeName_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_CofactorType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_CofactorType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_CofactorType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_CofactorType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_CofactorType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_CofactorType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_CommentType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_CommentType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_CommentType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_CommentType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_CommentType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_CommentType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_Component_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_Component_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_Component_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_Component_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_Component_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_Component_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_DbReferenceType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_DbReferenceType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_DbReferenceType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_DbReferenceType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_DbReferenceType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_DbReferenceType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_Domain_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_Domain_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_Domain_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_Domain_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_Domain_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_Domain_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_EventType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_EventType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_EventType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_EventType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_EventType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_EventType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_EvidenceType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_EvidenceType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_EvidenceType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_EvidenceType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_EvidenceType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_EvidenceType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_EvidencedStringType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_EvidencedStringType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_EvidencedStringType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_EvidencedStringType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_EvidencedStringType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_EvidencedStringType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_FeatureType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_FeatureType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_FeatureType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_FeatureType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_FeatureType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_FeatureType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_GeneLocationType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_GeneLocationType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_GeneLocationType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_GeneLocationType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_GeneLocationType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_GeneLocationType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_GeneNameType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_GeneNameType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_GeneNameType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_GeneNameType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_GeneNameType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_GeneNameType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_GeneType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_GeneType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_GeneType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_GeneType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_GeneType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_GeneType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_InteractantType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_InteractantType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_InteractantType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_InteractantType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_InteractantType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_InteractantType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_IsoformType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_IsoformType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_IsoformType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_IsoformType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_IsoformType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_IsoformType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_KeywordType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_KeywordType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_KeywordType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_KeywordType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_KeywordType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_KeywordType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_Link_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_Link_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_Link_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_Link_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_Link_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_Link_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_LocationType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_LocationType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_LocationType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_LocationType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_LocationType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_LocationType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_Name_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_Name_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_Name_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_Name_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_Name_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_Name_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_OrganismNameType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_OrganismNameType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_OrganismNameType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_OrganismNameType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_OrganismNameType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_OrganismNameType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_OrganismType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_OrganismType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_OrganismType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_OrganismType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_OrganismType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_OrganismType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_PhysiologicalReactionType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_PhysiologicalReactionType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_PhysiologicalReactionType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_PhysiologicalReactionType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_PhysiologicalReactionType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_PhysiologicalReactionType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_PropertyType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_PropertyType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_PropertyType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_PropertyType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_PropertyType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_PropertyType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_ReferenceType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_ReferenceType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_ReferenceType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_ReferenceType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_ReferenceType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_ReferenceType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_StatusType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_StatusType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_StatusType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_StatusType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_StatusType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_StatusType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_SubcellularLocationType_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_SubcellularLocationType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_SubcellularLocationType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_SubcellularLocationType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_SubcellularLocationType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_SubcellularLocationType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_SubmittedName_CTor', retval('int64_t'), [])
mod.add_function('Slice_uniprot_SubmittedName_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uniprot_SubmittedName_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uniprot_SubmittedName_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uniprot_SubmittedName_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_uniprot_SubmittedName_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Map_string_string_CTor', retval('int64_t'), [])
mod.add_function('Map_string_string_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Map_string_string_elem', retval('char*'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_string_contains', retval('bool'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_string_set', None, [param('int64_t', 'handle'), param('char*', 'key'), param('char*', 'value')])
mod.add_function('Map_string_string_delete', None, [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_string_keys', retval('int64_t'), [param('int64_t', 'handle')])
add_checked_function(mod, 'uniprot_Decoder_DecodeElement', retval('char*'), [param('int64_t', '_handle'), param('char*', 'v'), param('int64_t', 'start')])
add_checked_function(mod, 'uniprot_Decoder_Token', retval('int64_t'), [param('int64_t', '_handle')])
mod.add_function('uniprot_EvidencedStringType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_EvidencedStringType_Value_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_EvidencedStringType_Value_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_EvidencedStringType_Evidence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_EvidencedStringType_Evidence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_PhysiologicalReactionType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_PhysiologicalReactionType_DbReference_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_PhysiologicalReactionType_DbReference_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_PhysiologicalReactionType_Direction_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_PhysiologicalReactionType_Direction_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_PhysiologicalReactionType_Evidence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_PhysiologicalReactionType_Evidence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_PropertyType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_PropertyType_Type_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_PropertyType_Type_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_PropertyType_Value_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_PropertyType_Value_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_EvidenceType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_EvidenceType_Source_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_EvidenceType_Source_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_EvidenceType_ImportedFrom_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_EvidenceType_ImportedFrom_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_EvidenceType_Type_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_EvidenceType_Type_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_EvidenceType_Key_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_EvidenceType_Key_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Absorption_CTor', retval('int64_t'), [])
mod.add_function('uniprot_Absorption_Max_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Absorption_Max_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Absorption_Text_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Absorption_Text_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_ConsortiumType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_ConsortiumType_Name_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ConsortiumType_Name_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_DbReferenceType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_DbReferenceType_Molecule_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_DbReferenceType_Molecule_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_DbReferenceType_Property_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_DbReferenceType_Property_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_DbReferenceType_Type_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_DbReferenceType_Type_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_DbReferenceType_Evidence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_DbReferenceType_Evidence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_LocationType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_LocationType_Begin_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_LocationType_Begin_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_LocationType_End_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_LocationType_End_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_LocationType_Position_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_LocationType_Position_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_LocationType_Sequence_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_LocationType_Sequence_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_Transposon_CTor', retval('int64_t'), [])
mod.add_function('uniprot_Transposon_Value_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Transposon_Value_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_Transposon_Evidence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Transposon_Evidence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Anon6_CTor', retval('int64_t'), [])
mod.add_function('uniprot_Anon6_Type_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Anon6_Type_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_FeatureType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_FeatureType_Original_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_FeatureType_Original_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_FeatureType_Variation_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_FeatureType_Variation_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_FeatureType_Location_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_FeatureType_Location_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_FeatureType_Type_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_FeatureType_Type_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_FeatureType_Description_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_FeatureType_Description_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_FeatureType_Evidence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_FeatureType_Evidence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_OrganismNameType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_OrganismNameType_Value_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_OrganismNameType_Value_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_OrganismNameType_Type_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_OrganismNameType_Type_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_OrganismType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_OrganismType_Name_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_OrganismType_Name_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_OrganismType_DbReference_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_OrganismType_DbReference_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_OrganismType_Lineage_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_OrganismType_Lineage_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_OrganismType_Evidence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_OrganismType_Evidence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_ProteinExistenceType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_ProteinExistenceType_Type_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ProteinExistenceType_Type_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_SourceType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_SourceType_DbReference_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_SourceType_DbReference_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_GeneNameType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_GeneNameType_Value_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_GeneNameType_Value_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_GeneNameType_Evidence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_GeneNameType_Evidence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_GeneNameType_Type_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_GeneNameType_Type_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_Plasmid_CTor', retval('int64_t'), [])
mod.add_function('uniprot_Plasmid_Value_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Plasmid_Value_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_Plasmid_Evidence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Plasmid_Evidence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Name_CTor', retval('int64_t'), [])
mod.add_function('uniprot_Name_Value_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Name_Value_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_Name_Evidence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Name_Evidence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_ReferenceType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_ReferenceType_Citation_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ReferenceType_Citation_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_ReferenceType_Scope_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ReferenceType_Scope_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_ReferenceType_Source_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ReferenceType_Source_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_ReferenceType_Evidence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ReferenceType_Evidence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_ReferenceType_Key_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ReferenceType_Key_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_Disease_CTor', retval('int64_t'), [])
mod.add_function('uniprot_Disease_Name_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Disease_Name_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_Disease_Acronym_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Disease_Acronym_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_Disease_Description_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Disease_Description_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_Disease_DbReference_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Disease_DbReference_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Entry_CTor', retval('int64_t'), [])
mod.add_function('uniprot_Entry_Accession_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Entry_Accession_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Entry_Name_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Entry_Name_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Entry_Protein_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Entry_Protein_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Entry_Gene_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Entry_Gene_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Entry_Organism_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Entry_Organism_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Entry_OrganismHost_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Entry_OrganismHost_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Entry_GeneLocation_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Entry_GeneLocation_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Entry_Reference_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Entry_Reference_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Entry_Comment_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Entry_Comment_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Entry_DbReference_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Entry_DbReference_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Entry_ProteinExistence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Entry_ProteinExistence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Entry_Keyword_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Entry_Keyword_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Entry_Feature_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Entry_Feature_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Entry_Evidence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Entry_Evidence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Entry_Sequence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Entry_Sequence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Entry_Dataset_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Entry_Dataset_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_Entry_Created_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Entry_Created_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Entry_Modified_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Entry_Modified_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Entry_Version_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Entry_Version_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
add_checked_function(mod, 'uniprot_Entry_UnmarshalXML', retval('char*'), [param('int64_t', '_handle'), param('int64_t', 'd'), param('int64_t', 'start')])
mod.add_function('uniprot_KeywordType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_KeywordType_Value_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_KeywordType_Value_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_KeywordType_Evidence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_KeywordType_Evidence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_GeneType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_GeneType_Name_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_GeneType_Name_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_IsoformType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_IsoformType_Id_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_IsoformType_Id_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_IsoformType_Name_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_IsoformType_Name_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_IsoformType_Sequence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_IsoformType_Sequence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_IsoformType_Text_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_IsoformType_Text_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_NameListType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_NameListType_Consortium_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_NameListType_Consortium_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_NameListType_Person_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_NameListType_Person_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_ReactionType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_ReactionType_Text_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ReactionType_Text_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_ReactionType_DbReference_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ReactionType_DbReference_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_ReactionType_Evidence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ReactionType_Evidence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_ImportedFromType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_ImportedFromType_DbReference_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ImportedFromType_DbReference_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Lineage_CTor', retval('int64_t'), [])
mod.add_function('uniprot_Lineage_Taxon_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Lineage_Taxon_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_StatusType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_StatusType_Value_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_StatusType_Value_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_StatusType_Status_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_StatusType_Status_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_SubcellularLocationType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_SubcellularLocationType_Location_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_SubcellularLocationType_Location_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_SubcellularLocationType_Topology_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_SubcellularLocationType_Topology_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_SubcellularLocationType_Orientation_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_SubcellularLocationType_Orientation_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_SubmittedName_CTor', retval('int64_t'), [])
mod.add_function('uniprot_SubmittedName_FullName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_SubmittedName_FullName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_SubmittedName_EcNumber_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_SubmittedName_EcNumber_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CommentType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_CommentType_Molecule_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Molecule_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CommentType_Absorption_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Absorption_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CommentType_Kinetics_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Kinetics_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CommentType_PhDependence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_PhDependence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CommentType_RedoxPotential_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_RedoxPotential_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CommentType_TemperatureDependence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_TemperatureDependence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CommentType_Reaction_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Reaction_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CommentType_PhysiologicalReaction_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_PhysiologicalReaction_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CommentType_Cofactor_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Cofactor_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CommentType_SubcellularLocation_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_SubcellularLocation_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CommentType_Conflict_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Conflict_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CommentType_Link_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Link_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CommentType_Event_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Event_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CommentType_Isoform_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Isoform_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CommentType_Interactant_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Interactant_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CommentType_OrganismsDiffer_Get', retval('bool'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_OrganismsDiffer_Set', None, [param('int64_t', 'handle'), param('bool', 'val')])
mod.add_function('uniprot_CommentType_Experiments_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Experiments_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CommentType_Disease_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Disease_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CommentType_Location_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Location_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CommentType_Text_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Text_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CommentType_Type_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Type_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CommentType_LocationType_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_LocationType_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CommentType_Name_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Name_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CommentType_Mass_Get', retval('float'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Mass_Set', None, [param('int64_t', 'handle'), param('float', 'val')])
mod.add_function('uniprot_CommentType_Error_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Error_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CommentType_Method_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Method_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CommentType_Evidence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CommentType_Evidence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
add_checked_function(mod, 'uniprot_CommentType_UnmarshalXML', retval('char*'), [param('int64_t', '_handle'), param('int64_t', 'd'), param('int64_t', 'start')])
mod.add_function('uniprot_EventType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_EventType_Type_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_EventType_Type_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_PositionType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_PositionType_Position_Get', retval('uint64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_PositionType_Position_Set', None, [param('int64_t', 'handle'), param('uint64_t', 'val')])
mod.add_function('uniprot_PositionType_Status_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_PositionType_Status_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_PositionType_Evidence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_PositionType_Evidence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
add_checked_function(mod, 'uniprot_PositionType_UnmarshalXML', retval('char*'), [param('int64_t', '_handle'), param('int64_t', 'd'), param('int64_t', 'start')])
mod.add_function('uniprot_RedoxPotential_CTor', retval('int64_t'), [])
mod.add_function('uniprot_RedoxPotential_Text_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_RedoxPotential_Text_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CofactorType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_CofactorType_Name_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CofactorType_Name_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CofactorType_DbReference_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CofactorType_DbReference_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CofactorType_Evidence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CofactorType_Evidence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Conflict_CTor', retval('int64_t'), [])
mod.add_function('uniprot_Conflict_Sequence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Conflict_Sequence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Conflict_Type_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Conflict_Type_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_Strain_CTor', retval('int64_t'), [])
mod.add_function('uniprot_Strain_Value_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Strain_Value_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_Strain_Evidence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Strain_Evidence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_ProteinType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_ProteinType_RecommendedName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ProteinType_RecommendedName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_ProteinType_AlternativeName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ProteinType_AlternativeName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_ProteinType_SubmittedName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ProteinType_SubmittedName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_ProteinType_AllergenName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ProteinType_AllergenName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_ProteinType_BiotechName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ProteinType_BiotechName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_ProteinType_CdAntigenName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ProteinType_CdAntigenName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_ProteinType_InnName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ProteinType_InnName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_ProteinType_Domain_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ProteinType_Domain_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_ProteinType_Component_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_ProteinType_Component_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_RecommendedName_CTor', retval('int64_t'), [])
mod.add_function('uniprot_RecommendedName_FullName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_RecommendedName_FullName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_RecommendedName_ShortName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_RecommendedName_ShortName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_RecommendedName_EcNumber_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_RecommendedName_EcNumber_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_SequenceType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_SequenceType_Value_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_SequenceType_Value_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_SequenceType_Length_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_SequenceType_Length_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_SequenceType_Mass_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_SequenceType_Mass_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_SequenceType_Checksum_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_SequenceType_Checksum_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_SequenceType_Modified_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_SequenceType_Modified_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_SequenceType_Version_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_SequenceType_Version_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_SequenceType_Precursor_Get', retval('bool'), [param('int64_t', 'handle')])
mod.add_function('uniprot_SequenceType_Precursor_Set', None, [param('int64_t', 'handle'), param('bool', 'val')])
mod.add_function('uniprot_SequenceType_Fragment_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_SequenceType_Fragment_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
add_checked_function(mod, 'uniprot_SequenceType_UnmarshalXML', retval('char*'), [param('int64_t', '_handle'), param('int64_t', 'd'), param('int64_t', 'start')])
mod.add_function('uniprot_Component_CTor', retval('int64_t'), [])
mod.add_function('uniprot_Component_RecommendedName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Component_RecommendedName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Component_AlternativeName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Component_AlternativeName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Component_SubmittedName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Component_SubmittedName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Component_AllergenName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Component_AllergenName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Component_BiotechName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Component_BiotechName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Component_CdAntigenName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Component_CdAntigenName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Component_InnName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Component_InnName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Domain_CTor', retval('int64_t'), [])
mod.add_function('uniprot_Domain_RecommendedName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Domain_RecommendedName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Domain_AlternativeName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Domain_AlternativeName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Domain_SubmittedName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Domain_SubmittedName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Domain_AllergenName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Domain_AllergenName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Domain_BiotechName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Domain_BiotechName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Domain_CdAntigenName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Domain_CdAntigenName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Domain_InnName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Domain_InnName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_InteractantType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_InteractantType_Id_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_InteractantType_Id_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_InteractantType_Label_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_InteractantType_Label_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_InteractantType_DbReference_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_InteractantType_DbReference_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_InteractantType_IntactId_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_InteractantType_IntactId_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_Kinetics_CTor', retval('int64_t'), [])
mod.add_function('uniprot_Kinetics_KM_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Kinetics_KM_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Kinetics_Vmax_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Kinetics_Vmax_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Kinetics_Text_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Kinetics_Text_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Sequence_CTor', retval('int64_t'), [])
mod.add_function('uniprot_Sequence_Resource_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Sequence_Resource_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_Sequence_Version_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Sequence_Version_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_AlternativeName_CTor', retval('int64_t'), [])
mod.add_function('uniprot_AlternativeName_FullName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_AlternativeName_FullName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_AlternativeName_ShortName_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_AlternativeName_ShortName_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_AlternativeName_EcNumber_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_AlternativeName_EcNumber_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Link_CTor', retval('int64_t'), [])
mod.add_function('uniprot_Link_Uri_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Link_Uri_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_PhDependence_CTor', retval('int64_t'), [])
mod.add_function('uniprot_PhDependence_Text_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_PhDependence_Text_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_SourceDataType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_SourceDataType_Strain_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_SourceDataType_Strain_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_SourceDataType_Plasmid_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_SourceDataType_Plasmid_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_SourceDataType_Transposon_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_SourceDataType_Transposon_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_SourceDataType_Tissue_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_SourceDataType_Tissue_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Uniprot_CTor', retval('int64_t'), [])
mod.add_function('uniprot_Uniprot_Entry_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Uniprot_Entry_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Uniprot_Copyright_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Uniprot_Copyright_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CitationType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_CitationType_Title_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CitationType_Title_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CitationType_EditorList_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CitationType_EditorList_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CitationType_AuthorList_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CitationType_AuthorList_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CitationType_Locator_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CitationType_Locator_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CitationType_DbReference_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CitationType_DbReference_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_CitationType_Type_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CitationType_Type_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CitationType_Date_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CitationType_Date_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CitationType_Name_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CitationType_Name_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CitationType_Volume_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CitationType_Volume_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CitationType_First_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CitationType_First_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CitationType_Last_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CitationType_Last_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CitationType_Publisher_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CitationType_Publisher_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CitationType_City_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CitationType_City_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CitationType_Db_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CitationType_Db_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CitationType_Number_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CitationType_Number_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CitationType_Institute_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CitationType_Institute_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_CitationType_Country_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_CitationType_Country_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_GeneLocationType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_GeneLocationType_Name_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_GeneLocationType_Name_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_GeneLocationType_Type_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_GeneLocationType_Type_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_GeneLocationType_Evidence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_GeneLocationType_Evidence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_PersonType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_PersonType_Name_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_PersonType_Name_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_TemperatureDependence_CTor', retval('int64_t'), [])
mod.add_function('uniprot_TemperatureDependence_Text_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_TemperatureDependence_Text_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_Tissue_CTor', retval('int64_t'), [])
mod.add_function('uniprot_Tissue_Value_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Tissue_Value_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('uniprot_Tissue_Evidence_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('uniprot_Tissue_Evidence_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('uniprot_IntListType_CTor', retval('int64_t'), [])
mod.add_function('uniprot_IntListType_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('uniprot_IntListType_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('uniprot_IntListType_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('uniprot_IntListType_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('uniprot_IntListType_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
add_checked_function(mod, 'uniprot_IntListType_UnmarshalText', retval('char*'), [param('int64_t', '_handle'), param('int64_t', 'text')])

mod.generate(open('uniprot.c', 'w'))

